; CSTART.ASM  -  C startup-code for SIM68K

lomem  equ       $100             ; Lowest usable address
himem  equ       $10000           ; Highest memory addres + 1
;stklen equ       $1000            ; Default stacksize
;fatbase		equ		$380400
RS232_base	            equ			$DA8000
IDEbase			equ			$DA2000
IDEbase2		equ			$DA1000
SPIbase		equ			$DA4000
KEYbase		equ			$DE0000
;_secbuf		equ			$10000
buffer1		equ			$10200

; IDE register map
ide_data	            equ $00	; r/w
ide_error	            equ $04	; r
ide_features	equ $04	; w
ide_scount	            equ $08	; r/w
ide_lba0	            equ $0c	; r/w
ide_lba1	            equ $10	; r/w
ide_lba2	            equ $14	; r/w
ide_lba3	            equ $18	; r/w
ide_status	            equ $1c	; r
ide_command	equ $1c	; w

; IDE commands
idecmd_read_sector	equ $20
idecmd_write_sector	equ $30
idecmd_packet	equ $a0
idecmd_identify	equ $ec
idecmd_identifypacket	equ $a1


       org       0
       dc.l      himem
       dc.l      start
       org       lomem
       
       
start:
       lea       himem,A7
       move		 #$5555,_cachevalid
;       jsr		_ide_init
       bsr       _main
       bra.s     start
;       xdef      _exit
       xdef      __putch
__putch:                           ; Basic character output routine
       move.b    7(A7),$da8000
       rts
       
       xdef      _OSD
_OSD:       
;unsigned char OSD(unsigned char d)		
	   move.b 	#$80,$da4007
       move.b    7(A7),$de6003
       move.w	 $de6002,d0
	   move.b 	#$81,$da4007
       rts
       
       xdef      _SPI
_SPI:       
;unsigned char OSD(unsigned char d)	
	   move.b 	#$40,$da4007	;clk=low
	   bchg		#0,spipass
	   beq.s	@spi_1
	   ;lower byte
       move.b    7(A7),$DE8003
       move.w	 $DE8002,d0
	   move.b 	#$41,$da4007	;clk=high
       rts
@spi_1:      
;	   upperbyte
       move.b    7(A7),$DE8002
       move.w	 $DE8002,d0
       ror.w	#8,d0
       rts
      
       xdef		_EnableOsd
_EnableOsd:		
	   move.b 	#$20,$da4007
       rts
       
       xdef		_DisableOsd
_DisableOsd:		
	   move.b 	#$21,$da4007
       rts

       xdef		_EnableFpga
_EnableFpga:		
	   bclr		#0,spipass
	   move.b 	#$10,$da4007
       rts
       
       xdef		_DisableFpga
_DisableFpga:		
	   move.b 	#$11,$da4007
       rts
       
       
		xdef		_HandleHDF
_HandleHDF:
		move.w	$DEE008,d0
;		btst	#15,d0
		bpl.s	hdf2
;		move.w	#$0000,$DEE008
hdf1	move.w	$DA101C,d0
		bmi.s	hdf2	
		move.w	#$8000,$DEE008
hdf2:	rts
		
		
;cluster				ds.b	4	;$00		; 32-bit clusters
;part_fat			ds.b	4	;$04		; 32-bit start of fat
;part_rootdir		ds.b	4	;$08		; 32-bit root directory address
;part_cstart			ds.b	4	;$0c		; 32-bit start of clusters
;part_rootdirentrys	ds.b	2	;$10		; entris in root directory
;vol_fstype			ds.b	2	;$12
;vol_secperclus		ds.b	2	;$14
;scount				ds.b	2	;$16		; number of sectors to read
;dir_is_fat16root	ds.b	4	;$18		; marker for rootdir
;sector_ptr			ds.b	4	;$1c
;;dir_is_fat16root	equ	$20
;lba					ds.b	4	;$24
spipass 			ds.b	2	;$10000
;_volstart			ds.l	1	;start LBA of Volume
;_fatstart			ds.l	1	;start LBA of first FAT table
;_dirstart			ds.l	1	;start LBA of directory table
;_datastart			ds.l	1	;start LBA of data field
;_clustersize		ds.w	1	;size of a cluster in blocks
;_rootdirentrys		ds.w	1	;number of entry's in directory table


morphsector:
		move.l    	8(A7),A1
		move.l    	12(A7),D1	;sector
		move.l    	D1,D0	;Cluster
		movem.l		d2-d3,-(a7)
		moveq		#0,d2
		move.w		_clustersize,d2
		subq		#1,d2
		and.l		d2,d1
@sr_1:		
		lsr			#1,d2
		bcc.s		@sr_2
		lsr.l		#1,d0
		bra.s		@sr_1
@sr_2:							;d0-cluster, d1-sectoroffset
			move.w		(a1),d3		;entries
			subq.w		#1,d3
			moveq		#2,d2
@sr_4:		cmp.l		(a1,d2),d0
			bcs.s		@sr_3
			addq.w		#8,d2
			dbra		d3,@sr_4

@sr_3:		sub.l		-8(a1,d2),d0
			add.l		-4(a1,d2),d0

		move.w		_clustersize,d2
@sr_5:		
		lsr			#1,d2
		bcs.s		@sr_6
		add.l		d0,d0
		bra.s		@sr_5
@sr_6:
		add.l		d1,d0
		add.l		_datastart,d0
		movem.l		(a7)+,d2-d3
		rts
		

; unsigned char SectorRead(struct mntTYPE *table,unsigned long sector)
				xdef	_SectorRead 
_SectorRead:
				bsr	morphsector
_read_secbuf		
;	    bsr			debug_hex
				lea			_secbuf,a0
				cmp 		#$AAAA,_cachevalid
				bne.s		read_b11
				cmp.l		_cachelba,d0
				bne.s		read_b11
				moveq		#0,d0						;OK
				rts
read_b11:
				move		 #$AAAA,_cachevalid
				move.l		d0,_cachelba

_read_block
;	    bsr			debug_hex
				movem.l		a0/a1,-(a7)
				lea			IDEbase,a1            		;LBA  Secundar
				btst.w		#2,_drive
				beq.s		read_b0
				lea			IDEbase2,a1            		;LBA  Primaer
read_b0			btst.b		#7,ide_status(a1)     		;busy?
				bne.s			read_b0
				move.b		#1,ide_scount(a1)     		;Sector Count = 1

read_b1			btst.b		#7,ide_status(a1)     		;busy?
				bne			read_b1
				move.b		d0,ide_lba0(a1)       		;7..0

				ror.l		#8,d0
read_b2			btst.b		#7,ide_status(a1)     		;busy?
				bne			read_b2
				move.b		d0,ide_lba1(a1)       		;15..8

				ror.l		#8,d0
read_b3			btst.b		#7,ide_status(a1)     		;busy?
				bne			read_b3
				move.b		d0,ide_lba2(a1)				;23..16

				ror.l		#8,d0
				and.w		#$0F,d0
				or.b		_drive+1,d0					;master/slave
read_b4			btst.b		#7,ide_status(a1)     		;busy?
				bne			read_b4
				move.b		d0,ide_lba3(a1)       		;27..24

read_block6
				btst.b		#7,ide_status(a1)     		;busy?
				bne			read_block6
				
				move		#$8000,d0
read_block5
				btst.b		#6,ide_status(a1)     		;ready?
				dbne		d0,read_block5
				beq.s		read_block_err

				move.b		#idecmd_read_sector,ide_command(a1)	;Read Sector
;				move		#$8000,d0
;read_block8		btst.b		#7,ide_status(a1)
;				dbeq		d0,read_block8          		;wait for not busy
;				bne.s		read_block_err

				move		#$8000,d0
read_block9		btst.b		#3,ide_status(a1)
				dbne		d0,read_block9          		;wait for DRQ
				beq.s		read_block_err

				move		#31,d0                			;read 256 Words
read_block7		move.l		(a1),(a0)+
				move.l		(a1),(a0)+
				move.l		(a1),(a0)+
				move.l		(a1),(a0)+
				dbra		d0,read_block7

;				suba.l		#$200,a0
;				move		#511,d0                			;read 256 Words
;read_block17	move.b		(a0)+,RS232_base
;				dbra		d0,read_block17

				movem.l		(a7)+,a0/a1
				moveq		#0,d0						;OK
				rts
read_block_err	;move.b		#'E',RS232_base			
				movem.l		(a7)+,a0/a1
				move		 #$5555,_cachevalid			;invalid
				moveq		#-1,d0						;Failure
				rts
								
; unsigned char SectorWrite(struct mntTYPE *table,unsigned long sector)
				xdef	_SectorWrite 
_SectorWrite:
				bsr	morphsector
_write_secbuf:
				move		 #$5555,_cachevalid
				lea			_secbuf,a0
;	    bsr			debug_hex
				movem.l		a0/a1,-(a7)
				lea			IDEbase,a1            		;LBA  Secundar
				btst.w		#2,_drive
				beq.s		write_b0
				lea			IDEbase2,a1            		;LBA  Primaer
write_b0		btst.b		#7,ide_status(a1)     		;busy?
				bne			write_b0
				move.b		#1,ide_scount(a1)     		;Sector Count = 1

write_b1		btst.b		#7,ide_status(a1)     		;busy?
				bne			write_b1
				move.b		d0,ide_lba0(a1)       		;7..0

				ror.l		#8,d0
write_b2		btst.b		#7,ide_status(a1)     		;busy?
				bne			write_b2
				move.b		d0,ide_lba1(a1)       		;15..8

				ror.l		#8,d0
write_b3		btst.b		#7,ide_status(a1)     		;busy?
				bne			write_b3
				move.b		d0,ide_lba2(a1)				;23..16

				ror.l		#8,d0
				and.w		#$0F,d0
				or.b		_drive+1,d0					;master/slave
write_b4		btst.b		#7,ide_status(a1)     		;busy?
				bne			write_b4
				move.b		d0,ide_lba3(a1)       		;27..24

write_block6
				btst.b		#7,ide_status(a1)     		;busy?
				bne			write_block6
				
				move		#$8000,d0
write_block5
				btst.b		#6,ide_status(a1)     		;ready?
				dbne		d0,write_block5
				beq.s		write_block_err
				move.b		#idecmd_write_sector,ide_command(a1)	;write Sector

;				move		#$8000,d0
;write_block8	btst.b		#7,ide_status(a1)
;				dbeq		d0,write_block8          		;wait for not busy
;				bne.s		write_block_errf

;write_block8	btst.b		#7,ide_status(a1)
;				bne.s		write_block8          			;wait for not busy

				move		#$8000,d0
write_block9	btst.b		#3,ide_status(a1)
				dbne		d0,write_block9          		;wait for DRQ
				beq.s		write_block_err

				move		#31,d0                			;write 256 Words
;				move		#255,d0
write_block7	move.l		(a0)+,(a1)
				move.l		(a0)+,(a1)
				move.l		(a0)+,(a1)
				move.l		(a0)+,(a1)
;	move.w d0,(a1)
				dbra		d0,write_block7

;				suba.l		#$200,a0
;				move		#511,d0                			;write 256 Words
;write_block17	move.b		(a0)+,RS232_base
;				dbra		d0,write_block17

				movem.l		(a7)+,a0/a1
				moveq		#0,d0						;OK
				rts
write_block_err	movem.l		(a7)+,a0/a1
				moveq		#-1,d0						;Failure
				rts
				
;write_block_erre	move.b		#'E',RS232_base			
;				movem.l		(a7)+,a0/a1
;				moveq		#-1,d0						;Failure
;				rts
;								
;write_block_errf	move.b		#'F',RS232_base			
;				movem.l		(a7)+,a0/a1
;				moveq		#-1,d0						;Failure
;				rts
;write_block_errg	move.b		#'G',RS232_base			
;				movem.l		(a7)+,a0/a1
;				moveq		#-1,d0						;Failure
;				rts
				
;_ide_init:
;				lea			IDEbase,a1            		;LBA
;_ide_init2		btst.b		#7,ide_status(a1)     		;busy?
;				bne			_ide_init2
;				move.b		#$E0,ide_lba3(a1)       	;27..24
;
;				move.b		ide_status(a1),d0     		
;				beq.s		@done
;
;@checkrdy:
;_ide_init6
;				btst.b		#7,ide_status(a1)     		;busy?
;				bne			_ide_init6
;_ide_init5
;				btst.b		#6,ide_status(a1)     		;ready?
;				beq			_ide_init5
;	
;@done:
;				move.b		#idecmd_identify,ide_command(a1)	;Identify
;_ide_init8		btst.b		#7,ide_status(a1)
;				beq			_ide_init8           		;wait for busy
;
;_ide_init9		btst.b		#3,ide_status(a1)
;				beq			_ide_init9           		;wait for DRQ
;
;				move		#511,d0                			;read 256 Words
;_ide_init10		move.b		(a1),d1
;				move.b		d1,(a0)+
;	;move.b		d1,RS232_base
;				dbra		d0,_ide_init10
;				rts

;unsigned long GetSysCluster(void)
		xdef	_GetSysCluster 
_GetSysCluster:
		move.w		$dee004,d0
;		move		#$0700,d0
		
		btst		#8,d0
		beq.s		gsc2
		move.b		#$E0,d0		;Master
		btst		#9,d0
		beq.s		gsc0
		move.b		#$F0,d0		;Slave
gsc0	move.w		d0,_drive
		move.w		$dee000,d0
		swap		d0
		move.w		$dee002,d0
;		move.l		#$18f,d0
		
		move.l		d0,_dirstart
		moveq		#-1,d0
		rts
		
gsc2    moveq		#0,d0
		rts

		xdef  _kickcopy	
_kickcopy:
       move.l    (4,A7),A0
       move.l    (8,A7),A1
       move.l    (12,A7),D0
       addq.l	 #3,d0
       andi.w	 #$fffc,d0
kickcpy_1:
       move.l    (A1)+,(A0)+
       subq.l    #4,D0
       bne       kickcpy_1
       rts


;unsigned char _FindVolume(void)
		xdef	_FindVolume 
_FindVolume:
				lea			IDEbase,a1            		;LBA  Secundar
				btst.w		#2,_drive
				beq.s		fd_m1
				lea			IDEbase2,a1            		;LBA  Primaer
;;wait for 1K30 config ready			
fd_m1			move.b		ide_status(a1),d0       		;7..0
				btst.b		#7,d0     		;busy?
				bne			fd_m1
				btst.b		#6,d0     		;ready?
				beq			fd_m1
				
;		move.l		_dirstart,d0
;		rol.l			#8,d0
;		move.b		d0,RS232_base
;		rol.l			#8,d0
;		move.b		d0,RS232_base
;		rol.l			#8,d0
;		move.b		d0,RS232_base
;		rol.l			#8,d0
;		move.b		d0,RS232_base
				move.b		#$AA,ide_lba0(a1)       	;7..0
				move.b		ide_lba0(a1),d0       		;7..0
				cmpi.b		#$AA,d0
				bne.s		fd_m1
				move.b		#$55,ide_lba0(a1)       	;7..0
				move.b		ide_lba0(a1),d0       		;7..0
				cmpi.b		#$55,d0
				bne.s		fd_m1


;@checktype:
		moveq		#0,d0	;partitionstable
		move.l		d0,_volstart
		bsr			_read_secbuf
		bne.s 		@error
;	move.b		#'*',RS232_base			

		cmpi.b		#$55,$1fe(a0)
		bne.s		@error
		cmpi.b		#$AA,$1ff(a0)
		bne.s		@error
;	move.b		#'T',RS232_base	
			
		move.b		_drive,d0
		and.w		#$70,d0
		cmp.w		#$40,d0
		bcc.s		_testfat	;Superfloppy
	
		lea			_secbuf+$1be,a1		; pointer to partition table
		adda.w			d0,a1
;
;		move.b		4(a1),d0
;		cmpi.b		#01,d0		; fat12 uses $01
;		beq.s 		_foundfat
;		cmpi.b		#04,d0		; fat16 uses $04, $06, or $0e 
;		beq.s 		_foundfat
;		cmpi.b		#06,d0		; fat16 uses $04, $06, or $0e 
;		beq.s 		_foundfat
;		cmpi.b		#$0E,d0		; fat16 uses $04, $06, or $0e 
;		beq.s 		_foundfat
;		cmpi.b		#$0b,d0		; fat32 uses $0b or $0c
;		beq.s 		_foundfat
;		cmpi.b		#$0c,d0		; fat32 uses $0b or $0c
;		bne.s 		@next
		
;_foundfat:
;read_vol_sector	
;	move.b		#'F',RS232_base			
		move.l		8(a1),d0	;LBA
		ror.w		#8,d0
		swap		d0
		ror.w		#8,d0
		move.l		d0,_volstart
;		lea			_secbuf,a0
		bsr			_read_secbuf	; read sector 
		bne.s		@error
		cmpi.b		#$55,$1fe(a0)
		bne.s		@error
		cmpi.b		#$AA,$1ff(a0)
		beq.s		_testfat
;		bne.s		@error
;		bsr.s		_testfat
;		bne.s		@next
;		rts					;volume is loaded
@error:
;		move.b		#'E',RS232_base			
		moveq		#-1,d0
		rts

;@next:
;		move.b		#'X',RS232_base	
;		adda.w		#$10,a1
;		cmpa.l		#_secbuf+$1fe,a1
;		bne		@checktype
;test floppy format CF	

_testfat:
		cmpi.l		#$46415431,$36(a0)	;"FAT1"
		bne.s		_testfat_2
		move.b		#12,_fstype
		cmpi.l		#$32202020,$3A(a0)	;"2   "
		beq.s		_testfat_ex
		move.b		#16,_fstype
		cmpi.l		#$36202020,$3A(a0)	;"6   "
		beq.s		_testfat_ex
_testfat_2:
		move.b		#$00,_fstype
		cmpi.l		#$46415433,$52(a0)	;"FAT3"
		bne.s		@error
		cmpi.l		#$32202020,$56(a0)	;"2   "
		bne.s		@error
		move.b		#32,_fstype
_testfat_ex:
		move.l		$0a(a0),d0	; make sure sector size is 512
		and.l		#$FFFF00,d0
		cmpi.l		#$00200,d0
		bne		@error
;		and.l		#$FFFFFF00,d0
;		ror.l		#8,d0
;		cmpi.w		#$002,d0
;		bne.s		@error
;		swap		d0
;		move.w		d0,_clustersize	; number of sectors per cluster
		
			move.l		_volstart,d1
;			moveq		#0,d0
			move.w		$e(a0),d0		;reserved Sectors
			ror.w		#8,d0
			add.l		d0,d1
			move.l		d1,_fatstart			;Fat Table
		cmpi.b		#32,_fstype
		bne.s		 @fat16
		
;@fat32:
		move.l		$2c(a0),d0	; cluster of root directory
		ror.w		#8,d0
		swap		d0
		ror.w		#8,d0
;		move.l		d0,_dirstart	;cluster	
		move.l		d0,_rootcluster
; find start of clusters
		move.l		$24(a0),d0	;FAT Size
		ror.w		#8,d0
		swap		d0
		ror.w		#8,d0
_add_start32		
		add.l		d0,d1
		subq.b		#1,$10(a0)
		bne.s		_add_start32
		bra.s		subcluster
		
@fat16
			moveq		#0,d0
			move.l		d0,_rootcluster
			move.w		$16(a0),d0				;Sectors per Fat
			ror.w		#8,d0
root_sect	add.l		d0,d1
			subi.b		#1,$10(a0);d2			;number of FAT Copies
			bne			root_sect
;			move.l		d1,_dirstart			;Root sector - LBA
			move.l		d1,_rootsector
			
			move.b		$12(a0),d0
			lsl			#8,d0
			move.b		$11(a0),d0
			move		d0,_rootdirentrys
			lsr			#4,d0
			add.l		d0,d1
subcluster:	
			moveq		#0,d0
			move.b		$d(a0),d0
			move		d0,_clustersize
			sub.l		d0,d1					; subtract two clusters to compensate
			sub.l		d0,d1					; for reserved values 0 and 1
			move.l		d1,_datastart			;start of clusters
			
fat_ex:
			moveq		#0,d0
			rts


;;D0 to hex			
;debug_hex	movem.l		d1/a1,-(a7)
;			lea 		RS232_base,a1
;			move.b		#' ',(a1)
;			move.b		#' ',(a1)
;			move.b		#'-',(a1)
;			move.b		#'-',(a1)
;			moveq		#7,d1
;dhex2		rol.l		#4,d0	
;			swap		d1
;			move		d0,d1
;			and 		#$0F,d1
;			add			#$30,d1
;			cmp			#$3a,d1
;			bcs			dhex1
;			add			#$7,d1
;dhex1		move.b		d1,(a1)
;			swap		d1
;			dbra		d1,dhex2
;			move.b		#'-',(a1)
;			move.b		#'-',(a1)
;			move.b		#' ',(a1)
;			move.b		#' ',(a1)
;			movem.l		(a7)+,d1/a1
;			rts

fat_cdroot:
;			cmpi.b		#32,_fstype
			move.l		_dirstart,d0	; cluster of basic directory
			move.l		d0,_cluster	
			bne.s		 cdfat_32
		
			clr.l		_cluster
			move.w		_rootdirentrys,d0
			lsr			#4,d0
			move.w		d0,_sectorcnt
			move.l		_rootsector,d0
			move.l		d0,_sectorlba		;lba
			rts

cluster2lba:		
			move.l		_cluster,d0
cdfat_32:	
			move.w		_clustersize,d1
			move.w		d1,_sectorcnt
@fat32_1:		
			lsr			#1,d1
			bcs.s		@fat32_2
			lsl.l		#1,d0
			bra.s		@fat32_1
@fat32_2:
			add.l		_datastart,d0
			move.l		d0,_sectorlba	
			rts

;void ReadDir(const unsigned char *type, unsigned short entry)
			xdef	_ReadDir
_ReadDir:	
			movem.l   	D2/D3/D4/A2/A3,-(A7)
			moveq		#8,d3		;move.w		#_DIRSIZE,d3
			lea         _directory,A2
			move.l 		24(a7),a3	;unsigned char *type
			move.w		30(a7),d4	;entry
			bsr			fat_cdroot
rdir_loop:		
			bsr		_read_secbuf
			bne		rdir_error
			moveq	#0,d2
rdir_loop2:			
			move.b	(a0,d2.w),d0		;end
			beq		rdir_end
			
			cmp.b	#$e5,d0				;deleted
			beq		rdir_next
			cmp.b	#$2e,d0				;dot
			beq		rdir_next
			
			
			move.b	11(a0,d2.w),d0	
			move.b	d0,12(a2)				;attributs	
			and		#$1a,d0
			bne.s	rdir_next
			
;ext vergleichen			
			move.b	(A3),d0
;			cmpi.b	#'*',d0
;			beq.s	rdir_m10
			cmp.b	8(a0,d2.w),d0
			bne.s	rdir_next
			move.b	1(A3),d0
			cmp.b	9(a0,d2.w),d0
			bne.s	rdir_next
			move.b	2(A3),d0
			cmp.b	10(a0,d2.w),d0
			bne.s	rdir_next
			
rdir_m10:	move.l	(a0,d2.w),(a2)		;name
			move.l	4(a0,d2.w),4(a2)	;name
			move.l	8(a0,d2.w),8(a2)	;ext
			dbra	d4,rdir_next
			addq.w	#1,d4
			
			move.l	28(a0,d2.w),d0		;len
			ror.w	#8,d0
			swap	d0
			ror.w	#8,d0
			move.l	d0,18(a2)
			clr.w     16(A2)			;sector
			
			moveq	#0,d0
			cmpi.b	#32,_fstype
			bne.s	rdir_m3
			move.w	20(a0,d2.w),d0		;high cluster
			ror.w	#8,d0
			swap	d0
rdir_m3:	move.w	26(a0,d2.w),d0		;low cluster
			ror.w	#8,d0
			move.l	d0,22(a2)
			lea		26(a2),a2
			subq.w	#1,d3
			beq.s	rdir_end2
rdir_next
			add.w	#$20,d2
			cmpi.w	#$200,d2
			bcs		rdir_loop2
;next sector			
			move.l 		_sectorlba,d0	
			addq.l		#1,d0		 
			move.l 		d0,_sectorlba			 

			subi.w		#1,_sectorcnt
			bne 		rdir_loop
			bsr			next_cluster
			beq.s		rdir_end
			bsr			cluster2lba		
			bra 		rdir_loop
				
rdir_error:
rdir_end:	clr.l	18(a2)		;len
			lea		26(a2),a2
			subq.w	#1,d3
			beq.s	rdir_end
rdir_end2:	
			movem.l   	(a7)+,D2/D3/D4/A2/A3
			moveq		#0,d0
			rts


		
		xdef	_SearchFile 
_SearchFile:

			move.l 		4(a7),a1	;ptr name
			bsr			fat_cdroot
			;d0 - LBA
fat_findfile
			bsr			_read_secbuf
			move.l		d2,-(a7)
			moveq		#15,d2
fat_findfile_m3
			moveq		#10,d0
fat_findfile_m2			
			move.b		(a1,d0),d1
			cmp.b		(a0,d0),d1
			beq			fat_findfile_m1
			add.b		#$20,d1
			cmp.b		(a0,d0),d1
			bne			fat_findfile_m9
fat_findfile_m1					
			dbra		d0,fat_findfile_m2
;file found	
			moveq	#0,d0
			move.b	11(a0),d0
			move.w	d0,_attrib
			cmpi.b		#32,_fstype
			bne.s		 sfs_m3
			move.w	20(a0),d0		;high cluster
			ror.w	#8,d0
			swap	d0
sfs_m3:		move.w	26(a0),d0		;high cluster
			ror.w	#8,d0
			move.l	d0,_cluster
			move.l		(a7)+,d2
			moveq	#-1,d0
			rts


fat_findfile_m9
			adda		#$0020,a0
			dbra		d2,fat_findfile_m3		
			
;fat_read_next_sector:
			move.l		(a7)+,d2
			move.l 		_sectorlba,d0	
			addq.l		#1,d0		 
			move.l 		d0,_sectorlba			 

			subi.w		#1,_sectorcnt
			bne 		fat_findfile
			bsr			next_cluster
			beq.s		fat_findfile_m8
			bsr			cluster2lba		
			bra			fat_findfile
fat_findfile_m8			
			moveq		#0,d0			;file not found
			rts

		xdef	_LoadFile 
_LoadFile:
			move.l 		4(a7),a0	;Loadaddr
_LoadFile2:
			bsr			cluster2lba
_LoadFile1:	
			bsr			_read_block
			bne.s		lferror
			
;fat_read_next_sector:
			adda.l		#$200,a0
			move.l 		_sectorlba,d0	
			addq.l		#1,d0		 
			move.l 		d0,_sectorlba			 

			subi.w		#1,_sectorcnt
			bne 		_LoadFile1
			move.l		a0,-(a7)
			bsr			next_cluster
			move.l		(a7)+,a0
			bne			_LoadFile2
;			moveq		#0,d0
			move.l		a0,d0
			rts
lferror:	moveq		#0,d0		
			rts
			
			
next_cluster:
		cmpi.b		#32,_fstype
		beq.s		 fnc_m32
		cmpi.b		#12,_fstype
		beq.s		 fnc_m12

;FAT16
		move.l    	_cluster,D0
		lsr.l     	#8,D0
		add.l		_fatstart,D0
		bsr			_read_secbuf
		bne.s		fnc_end
;		moveq		#0,d0
		move.b    	_cluster+3,D0
		add.w		d0,d0
		move.w		(a0,d0),d0
		ror.w		#8,d0
		move.l    	D0,_cluster
		or.l		#$ffff000f,d0
		cmp.w		#$ffff,d0
		rts
fnc_m32:	
;FAT32
		move.l    	_cluster,D0
		lsr.l     	#7,D0
		add.l		_fatstart,D0
		bsr			_read_secbuf
		bne.s		fnc_end
;		moveq		#0,d0
		move.b    	_cluster+3,D0
		and.w		#$7f,d0
		add.w		d0,d0
		add.w		d0,d0
		move.l		(a0,d0),d0
		ror.w		#8,d0
		swap		d0
		ror.w		#8,d0
		move.l    	D0,_cluster
		or.l		#$f0000007,d0
		cmp.l		#$ffffffff,d0
		rts
fnc_end:
		moveq		#0,d0
		rts
		

fnc_m12:	
;FAT12
		move.l		d2,-(a7)
		move.l    	_cluster,D0	;cluster
;	bsr	debug_hex
		move.l		d0,d1
		add.l		d0,d0
		add.l		d1,d0		;*3
		move.l		d0,d1		;nibbles
		lsr.l     	#8,D0		
		lsr.l     	#2,D0		;cluster*1.5/256
		add.l		_fatstart,D0
		move.l		d0,d2
;	bsr	debug_hex
		bsr			_read_secbuf
		bne.s		fnc_end2
		move.l		d1,d0
		lsr.l		#1,d0
		and.w		#$1ff,d0
		cmp			#$1ff,d0
		bne			fnc_m14
		
		move.b		(a0,d0),d0
		exg.l		d0,d2
		addq.l		#1,d0
		bsr			_read_secbuf
		bne.s		fnc_end2
		lsl			#8,d2
		move.b		(a0),d2
		bra.s		fnc_m15
		
fnc_m14:		
		move.b		(a0,d0),d2
		lsl			#8,d2
		move.b		1(a0,d0.w),d2
fnc_m15:
		rol.w		#8,d2
		and			#1,d1
		beq.s		fnc_m13
		lsr			#4,d2
fnc_m13:
		and.l		#$FFF,d2
		move.l    	D2,_cluster
		or.l		#$fffff00f,d2
		move.l		d2,d0
;	move.l	d2,d0	
;	bsr	debug_hex
		move.l		(a7)+,d2
		cmp.w		#$ffff,d0
		rts

fnc_end2:
		move.l		(a7)+,d2
		moveq		#0,d0
		rts
		
;unsigned char MountFile(struct mntTYPE *table)
		xdef	_MountFile 
_MountFile:
			move.l 		4(a7),a1	;mounttable
			movem.l		d3-d6,-(a7)
			move.w		(a1),d3		;entries
			subq.l		#1,d3
			clr.w		(a1)
			moveq		#2,d6
			moveq		#0,d4		;cluster im file
			move.l      6(a1),d5	;startcluster in partition	
			move.l    	D5,_cluster
mf_2:		move.l		d4,(a1,d6)
			move.l		d5,4(a1,d6)
			addq.l		#8,d6
			addq.w		#1,(a1)
mf_1:		bsr 		next_cluster
			beq.s		mf_rts		;ende d0<>FFFFFF->fehler
			addq.l		#1,d4
			addq.l		#1,d5
			cmp.l  		_cluster,d5
			beq.s		mf_1
			move.l  	_cluster,d5
			dbra.s 		d3,mf_2
mf_err:		moveq		#0,d0		;to many fragments
			movem.l		(a7)+,d3-d6
			rts
			
mf_rts:		and.l		d0,d0
			beq.s		mf_err
			move.w		(a1),d0
			movem.l		(a7)+,d3-d6
			rts

		
		
			