; C:\_FPGA\_CONE\C1EXTENDER\C1EXTENDER\JBROM\MAIN.C - Compiled by CC68K  Version 5.00 (c) 1991-2005  Peter J.Fondse
; /*
; Copyright 2005, 2006, 2007 Dennis van Weeren
; This file is part of Minimig
; Minimig is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 3 of the License, or
; (at your option) any later version.
; Minimig is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.
; Minimig boot controller / floppy emulator / on screen display
; 27-11-2005              -started coding
; 29-01-2005              -done a lot of work
; 06-02-2006              -it start to look like something!
; 19-02-2006              -improved floppy dma offset code
; 02-01-2007              -added osd support
; 11-02-2007              -added insert floppy progress bar
; 01-07-2007              -added filetype filtering for directory routines
; JB:
; 2008-07-18              -better read support (sector loaders are now less confused)
; -write support added (strict sector format checking - may not work with non DOS games)
; -removed bug in filename filtering (initial directory fill didn't filter)
; -communication interface with new bootloader
; -OSD control of reset, ram configuration, interpolation filters and kickstart
; WriteTrack errors:
; #20 : unexpected dma transfer end (sector header)
; #21 : no second sync word found
; #22 : first header byte not 0xFF
; #23 : second header byte (track number) not within 0..159 range
; #24 : third header byte (sector number) not within 0..10 range
; #25 : fourth header byte (sectors to gap number) not within 1..11 range
; #26 : header checksum error
; #27 : track number in sector header not the same as drive head position
; #28 : unexpected dma transfer end (sector data)
; #29 : data checksum error
; #30 : write attempt to protected disk
; 2008-07-25              -update of write sector header format checking
; -disk led active during writes to disk
; TobiFlex:
; 2008-11-...			port to C-One
; rewrite some parts in 68000 asm code
; */
; #include <stdio.h>
; #include <string.h>
; #include "osd.h"
; #include "fat1618_2.h"
; //#define DEBUG
; void CheckTrack(struct adfTYPE *drive);
; void ReadTrack(struct adfTYPE *drive);
; void WriteTrack(struct adfTYPE *drive);
; unsigned char FindSync(struct adfTYPE *drive);
; unsigned char GetHeader(unsigned char *pTrack, unsigned char *pSector);
; unsigned char GetData();
; //char BootPrint(const char* text);
; void BootExit(void);
; void ErrorMessage(const char* message, unsigned char code);
; unsigned short SectorToFpga(unsigned char sector,unsigned char track);
; void SectorGapToFpga(void);
; void SectorHeaderToFpga(unsigned char);
; void HandleFpgaCmd(unsigned char c1, unsigned char c2);
; void InsertFloppy(struct adfTYPE *drive);
; void PrintDir(void);
; void User(void);
; /*FPGA commands <c1> argument*/
; #define         CMD_USERSELECT          0x80    /*user interface SELECT*/
; #define         CMD_USERUP                      0x40    /*user interface UP*/
; #define         CMD_USERDOWN            0x20    /*user interface DOWN*/
; #define         CMD_GETDSKSTAT          0x04    /*FPGA requests status of disk drive*/
; #define         CMD_RDTRCK                      0x02    /*FPGA requests reading of track <c2>*/
; #define         CMD_WRTRCK                      0x01    /*FPGA requests writing of trck <c2>*/
; #define         ST_READREQ      0x02
; /*floppy status*/
; #define         DSK_INSERTED            0x01    /*disk is inserted*/
; #define         DSK_WRITABLE            0x02    /*disk is writable*/
; /*menu states*/
; #define         MENU_NONE1                      0               /*no menu*/
; #define         MENU_NONE2                      1               /*no menu*/
; #define         MENU_MAIN1                      2               /*main menu*/
; #define         MENU_MAIN2                      3               /*main menu*/
; #define         MENU_FILE1                      4               /*file requester menu*/
; #define         MENU_FILE2                      5               /*file requester menu*/
; #define         MENU_RESET1                     6               /*reset menu*/
; #define         MENU_RESET2                     7               /*reset menu*/
; #define         MENU_SETTINGS1          8               /*settings menu*/
; #define         MENU_SETTINGS2          9               /*settings menu*/
; #define         MENU_ROMSELECT1         10              /*rom select menu*/
; #define         MENU_ROMSELECT2         11              /*rom select menu*/
; #define         MENU_ROMFILE1           12              /*rom file select menu*/
; #define         MENU_ROMFILE2           13              /*rom file select menu*/
; #define         MENU_ERROR                      127             /*error message menu*/
; /*other constants*/
; #define         DIRSIZE                         8               /*size of directory display window*/
; #define         REPEATTIME                      50              /*repeat delay in 10ms units*/
; #define         REPEATRATE                      5               /*repeat rate in 10ms units*/
; #define         EEPROM_LRFILTER         0x10
; #define         EEPROM_HRFILTER         0x11
; #define         EEPROM_MEMCFG           0x12
; #define         EEPROM_KICKNAME         0x18    /*size 8*/
; #define         MOUNT_ENTRIES         0x8    /*size 8*/
; /*variables*/
; struct adfTYPE
; {
; unsigned short entries;                         /*max. possible fragments */
; unsigned long fragment[2*MOUNT_ENTRIES];        /*fragments*/
; unsigned char status;                           /*status of floppy*/
; unsigned char sectoroffset;                     /*sector offset to handle tricky loaders*/
; unsigned char track;                            /*current track*/
; unsigned char trackprev;                        /*previous track*/
; unsigned char name[12];                         /*floppy name*/
; };
; struct adfTYPE df0,df1,df2,df3,*aktdrive,*seldrive;                                             /*drive 0 information structure*/
; struct file2TYPE file;                                  /*global file handle*/
; struct file2TYPE directory[DIRSIZE];    /*directory array*/
; unsigned char dirptr;                                   /*pointer into directory array*/
; //unsigned char menustate = MENU_NONE1;
; unsigned char menustate;
; unsigned char menusub;
; unsigned char s[25];                                    /*used to build strings*/
; unsigned char lr_filter;
; unsigned char hr_filter;
; const char* filter_msg[] = {"none","HOR ","VER ","H+V "};
; unsigned char memcfg;
; const char* memcfg_msg[] = {"512K CHIP/8MB","2Meg CHIP/8MB","512K/512K/8MB","2MB/1MB/8MB  "};
; unsigned short first_dir_entry;
; unsigned char Error;
; unsigned char fstype;
; /*This is where it all starts after reset*/
; main(void)
; {
       section   code
       xdef      _main
_main:
       link      A6,#-12
       movem.l   A2/A3,-(A7)
       lea       _file,A2
       lea       _df0,A3
; unsigned char c1,c2;
; unsigned short t;
; unsigned char c;
; unsigned char i;
; unsigned long clu;
; //        unsigned char c3,c4;
; OsdDisable();
       bsr       _OsdDisable
; menustate = MENU_NONE1;
       clr.b     _menustate
; menusub = 0;
       clr.b     _menusub
; aktdrive=&df0;
       move.l    A3,_aktdrive
; lr_filter = 0;
       clr.b     _lr_filter
; hr_filter = 0;
       clr.b     _hr_filter
; memcfg = 3;
       move.b    #3,_memcfg
; while (!GetSysCluster());
main_1:
       bsr       _GetSysCluster
       tst.l     D0
       bne.s     main_3
       bra       main_1
main_3:
; BootPrint("SysCluster found");
       pea       @main_9
       bsr       _BootPrint
       addq.w    #4,A7
; //        OsdClear();
; //        OsdWrite(0,"SysCluster found",1);
; //        OsdEnable();
; //        clu=dirstart;
; //                c = (clu&0xF) + '0';
; //                if (c>'9')
; //                        c += 'A'-'9'-1;
; //                s[3]=c;
; //                
; //                c = ((clu>>4)&0xF) + '0';
; //                if (c>'9')
; //                        c += 'A'-'9'-1;
; //                s[2]=c;
; //                
; //                c = ((clu>>8)&0xF) + '0';
; //                if (c>'9')
; //                        c += 'A'-'9'-1;
; //                s[1]=c;
; //                c = ((clu>>12)&0xF) + '0';
; //                if (c>'9')
; //                        c += 'A'-'9'-1;
; //                s[0]=c;
; //        clu=drive;
; //        s[4] = ' ';
; //                c = ((clu>>8)&0xF) + '0';
; //                if (c>'9')
; //                        c += 'A'-'9'-1;
; //                s[6]=c;
; //                c = ((clu>>12)&0xF) + '0';
; //                if (c>'9')
; //                        c += 'A'-'9'-1;
; //                s[5]=c;
; //        s[7] = 0;
; //        OsdWrite(2,s,0);
; /*initalize FAT partition*/
; if (!FindVolume()==0)
       bsr       _FindVolume
       tst.l     D0
       bne.s     main_6
       moveq     #1,D0
       bra.s     main_7
main_6:
       clr.l     D0
main_7:
       tst.l     D0
       bne.s     main_4
; {
; //                puts("No filesystem found!\r");
; ErrorMessage("No filesystem found!",0);
       clr.l     -(A7)
       pea       @main_10
       bsr       _ErrorMessage
       addq.w    #8,A7
; while(1);
main_8:
       bra       main_8
main_4:
; }
; //        else
; //        {       switch (fstype)
; //				{
; //					case 12:
; //							puts("FAT12 filesystem found!\r");
; //							break;
; //					case 16:
; //							puts("FAT16 filesystem found!\r");
; //							break;
; //					case 32:
; //							puts("FAT32 filesystem found!\r");
; //							break;
; //				}
; //        }
; //        BootPrint("** 68K firmware 111108 **\n");
; df0.status=0;
       clr.b     66(A3)
; df1.status=0;
       clr.b     _df1+66
; df2.status=0;
       clr.b     _df2+66
; df3.status=0;
       clr.b     _df3+66
; if (SearchFile("KICK    ROM"))
       pea       @main_11
       bsr       _SearchFile
       addq.w    #4,A7
       tst.l     D0
       beq.s     main_11
; {
; //                puts("Kick.rom found!\r");
; if (LoadFile(0x580000)<=0x5C0000)			//0xf8 XOR 0xA0
       pea       5767168
       bsr       _LoadFile
       addq.w    #4,A7
       cmp.l     #6029312,D0
       bgt.s     main_13
; kickcopy(0x5C0000,0x580000,0x40000);
       pea       262144
       pea       5767168
       pea       6029312
       bsr       _kickcopy
       add.w     #12,A7
main_13:
       bra.s     main_12
main_11:
; }
; else
; {
; ErrorMessage(" No KICK.ROM found!",0);
       clr.l     -(A7)
       pea       @main_12
       bsr       _ErrorMessage
       addq.w    #8,A7
; while(1);
main_15:
       bra       main_15
main_12:
; }
; if (SearchFile("DF0     ADF"))
       pea       @main_13
       bsr       _SearchFile
       addq.w    #4,A7
       tst.l     D0
       beq.s     main_18
; {
; //                puts("DF0.ADF found!\r");
; file.cluster=cluster;
       move.l    _cluster,22(A2)
; strncpy(file.name,"DF0     ADF",11);
       pea       11
       pea       @main_14
       move.l    A2,-(A7)
       bsr       _strncpy
       add.w     #12,A7
; file.attributes=attrib;
       move.w    _attrib,D0
       move.b    D0,12(A2)
; InsertFloppy(&df0);
       move.l    A3,-(A7)
       bsr       _InsertFloppy
       addq.w    #4,A7
main_18:
; }
; ////        if (!CheckButton())     /*if menu button pressed don't load Action Replay*/
; //        if (SearchFile("AR3     ROM"))
; //        {
; ////                puts("Uploading Action Replay ROM...\r");
; //                LoadFile(0x080000);
; //        }
; OsdFilter(lr_filter,hr_filter); /*set interpolation filters*/
       move.b    _hr_filter,D1
       and.l     #255,D1
       move.l    D1,-(A7)
       move.b    _lr_filter,D1
       and.l     #255,D1
       move.l    D1,-(A7)
       bsr       _OsdFilter
       addq.w    #8,A7
; OsdMemoryConfig(memcfg);                /*set memory config*/
       move.b    _memcfg,D1
       and.l     #255,D1
       move.l    D1,-(A7)
       bsr       _OsdMemoryConfig
       addq.w    #4,A7
; BootExit();
       bsr       _BootExit
; /******************************************************************************/
; /******************************************************************************/
; /*System is up now*/
; /******************************************************************************/
; /******************************************************************************/
; /*fill initial directory*/
; ReadDir("ADF",0);
       clr.l     -(A7)
       pea       @main_15
       bsr       _ReadDir
       addq.w    #8,A7
; first_dir_entry=0;
       clr.w     _first_dir_entry
; dirptr = 0;
       clr.b     _dirptr
; /*get initial timer for checking user interface*/
; while(1)
main_20:
; {
; /*read command from FPGA*/
; EnableFpga();
       bsr       _EnableFpga
; c1=SPI(0);
       clr.l     -(A7)
       bsr       _SPI
       addq.w    #4,A7
       move.b    D0,-10(A6)
; c2=SPI(0);
       clr.l     -(A7)
       bsr       _SPI
       addq.w    #4,A7
       move.b    D0,-9(A6)
; DisableFpga();
       bsr       _DisableFpga
; /*handle command*/
; HandleFpgaCmd(c1,c2);
       move.b    -9(A6),D1
       and.l     #255,D1
       move.l    D1,-(A7)
       move.b    -10(A6),D1
       and.l     #255,D1
       move.l    D1,-(A7)
       bsr       _HandleFpgaCmd
       addq.w    #8,A7
; HandleHDF();
       bsr       _HandleHDF
; /*handle user interface*/
; User();
       bsr       _User
       bra       main_20
; }
; }
; char BootPrint(const char* text)
; {
       xdef      _BootPrint
_BootPrint:
       link      A6,#-4
       movem.l   D2/D3/D4/D5/D6/A2/A3,-(A7)
       lea       _SPI,A2
       lea       _DisableFpga,A3
; unsigned char c1,c2,c3,c4;
; char cmd;
; const unsigned char* p;
; unsigned char n;
; p = text;
       move.l    8(A6),D4
; n = 0;
       clr.b     D3
; while (*(p++) != 0)
BootPrint_1:
       move.l    D4,A0
       addq.l    #1,D4
       move.b    (A0),D0
       and.l     #255,D0
       beq.s     BootPrint_3
; n++; /*calculating string length*/
       addq.b    #1,D3
       bra       BootPrint_1
BootPrint_3:
; cmd = 1;
       moveq     #1,D6
; while (1)
BootPrint_4:
; {
; EnableFpga();
       bsr       _EnableFpga
; c1=SPI(0x12);
       pea       18
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,-2(A6)
; c2=SPI(0x34);
       pea       52
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,-1(A6)
; c3=SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D5
; c4=SPI(1);      /*disk present*/
       pea       1
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D2
; /*printf("CMD%d:%02X,%02X,%02X,%02X\r",cmd,c1,c2,c3,c4);*/
; if (c1 == CMD_RDTRCK)
       move.b    -2(A6),D0
       and.l     #255,D0
       cmp.l     #2,D0
       bne       BootPrint_10
; {
; if (cmd)
       tst.b     D6
       beq       BootPrint_9
; {/*command phase*/
; if (c3==0x80 && c4==0x06)       /*command packet size 12 bytes*/
       and.l     #255,D5
       cmp.l     #128,D5
       bne       BootPrint_11
       and.l     #255,D2
       cmp.l     #6,D2
       bne       BootPrint_11
; {
; cmd = 0;;
       clr.b     D6
; SPI(0xAA);      /*command header*/
       pea       170
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x55);
       pea       85
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x00);      /*cmd: 0001 = print*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x01);
       pea       1
       jsr       (A2)
       addq.w    #4,A7
; /*data packet size in bytes*/
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(n+2); /*+2 because only even byte count is possible to send and we have to send termination zero byte*/
       moveq     #2,D1
       and.l     #255,D3
       add.l     D3,D1
       move.l    D1,-(A7)
       jsr       (A2)
       addq.w    #4,A7
; /*don't care*/
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       bra.s     BootPrint_12
BootPrint_11:
; }
; else break;
       bra       BootPrint_6
BootPrint_12:
       bra       BootPrint_10
BootPrint_9:
; }
; else
; {/*data phase*/
; if (c3==0x80 && c4==((n+2)>>1))
       and.l     #255,D5
       cmp.l     #128,D5
       bne       BootPrint_13
       and.l     #255,D2
       moveq     #2,D0
       and.l     #255,D3
       add.l     D3,D0
       asr.l     #1,D0
       cmp.l     D0,D2
       bne       BootPrint_13
; {
; p = text;
       move.l    8(A6),D4
; n = c4<<1;
       and.l     #255,D2
       move.l    D2,D0
       asl.l     #1,D0
       move.b    D0,D3
; while (n--)
BootPrint_15:
       move.b    D3,D0
       subq.b    #1,D3
       tst.b     D0
       beq.s     BootPrint_17
; {
; c4 = *p;
       move.l    D4,A0
       move.b    (A0),D2
; SPI(c4);
       and.l     #255,D2
       move.l    D2,-(A7)
       jsr       (A2)
       addq.w    #4,A7
; if (c4) /*if current character is not zero go to next one*/
       tst.b     D2
       beq.s     BootPrint_18
; p++;
       addq.l    #1,D4
BootPrint_18:
       bra       BootPrint_15
BootPrint_17:
; }
; DisableFpga();
       jsr       (A3)
; return 1;
       moveq     #1,D0
       bra.s     BootPrint_20
BootPrint_13:
; }
; else break;
       bra.s     BootPrint_6
BootPrint_10:
; }
; }
; DisableFpga();
       jsr       (A3)
       bra       BootPrint_4
BootPrint_6:
; }
; DisableFpga();
       jsr       (A3)
; return 0;
       clr.b     D0
BootPrint_20:
       movem.l   (A7)+,D2/D3/D4/D5/D6/A2/A3
       unlk      A6
       rts
; }
; void BootExit(void)
; {
       xdef      _BootExit
_BootExit:
       link      A6,#-4
       movem.l   A2,-(A7)
       lea       _SPI,A2
; unsigned char c1,c2,c3,c4;
; while (1)
BootExit_1:
; {
; EnableFpga();
       bsr       _EnableFpga
; c1 = SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,-4(A6)
; c2 = SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,-3(A6)
; c3 = SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,-2(A6)
; c4 = SPI(1);    /*disk present*/
       pea       1
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,-1(A6)
; if (c1 == CMD_RDTRCK)
       move.b    -4(A6),D0
       and.l     #255,D0
       cmp.l     #2,D0
       bne       BootExit_4
; {
; if (c3==0x80 && c4==0x06)       /*command packet size 12 bytes*/
       move.b    -2(A6),D0
       and.l     #255,D0
       cmp.l     #128,D0
       bne       BootExit_6
       move.b    -1(A6),D0
       and.l     #255,D0
       cmp.l     #6,D0
       bne       BootExit_6
; {
; SPI(0xAA);      /*command header*/
       pea       170
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x55);
       pea       85
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x00);      /*cmd: 0003 = restart*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x03);
       pea       3
       jsr       (A2)
       addq.w    #4,A7
; /*don't care*/
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; /*don't care*/
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
BootExit_6:
; }
; DisableFpga();
       bsr       _DisableFpga
; return;
       bra.s     BootExit_8
BootExit_4:
; }
; DisableFpga();
       bsr       _DisableFpga
       bra       BootExit_1
BootExit_8:
       movem.l   (A7)+,A2
       unlk      A6
       rts
; }
; }
; /*user interface*/
; void User(void)
; {
       xdef      _User
_User:
       movem.l   D2/D3/D4/D5/D6/A2/A3/A4/A5,-(A7)
       lea       _menustate,A2
       lea       _s,A3
       lea       _OsdWrite,A4
       lea       _strcpy,A5
; unsigned char c,up,down,select,menu;
; /*get user control codes*/
; c=OsdGetCtrl();
       bsr       _OsdGetCtrl
       move.b    D0,D6
; /*decode and set events*/
; up=0;
       clr.b     D5
; down=0;
       clr.b     D4
; select=0;
       clr.b     D2
; menu=0;
       clr.b     D3
; if (c&OSDCTRLUP)
       and.l     #255,D6
       move.l    D6,D0
       and.l     #1,D0
       beq.s     User_1
; up=1;
       moveq     #1,D5
User_1:
; if (c&OSDCTRLDOWN)
       and.l     #255,D6
       move.l    D6,D0
       and.l     #2,D0
       beq.s     User_3
; down=1;
       moveq     #1,D4
User_3:
; if (c&OSDCTRLSELECT)
       and.l     #255,D6
       move.l    D6,D0
       and.l     #4,D0
       beq.s     User_5
; select=1;
       moveq     #1,D2
User_5:
; if (c&OSDCTRLMENU)
       and.l     #255,D6
       move.l    D6,D0
       and.l     #8,D0
       beq.s     User_7
; menu=1;
       moveq     #1,D3
User_7:
; /*menu state machine*/
; switch (menustate)
       move.b    (A2),D0
       and.l     #255,D0
       cmp.l     #5,D0
       beq       User_16
       bhi.s     User_23
       cmp.l     #2,D0
       beq       User_13
       bhi.s     User_24
       cmp.l     #1,D0
       beq       User_12
       bhi       User_9
       tst.l     D0
       beq       User_11
       bra       User_9
User_24:
       cmp.l     #4,D0
       beq       User_15
       bhi       User_9
       cmp.l     #3,D0
       beq       User_14
       bra       User_9
User_23:
       cmp.l     #8,D0
       beq       User_19
       bhi.s     User_25
       cmp.l     #7,D0
       beq       User_18
       bhi       User_9
       cmp.l     #6,D0
       beq       User_17
       bra       User_9
User_25:
       cmp.l     #127,D0
       beq       User_21
       bhi       User_9
       cmp.l     #9,D0
       beq       User_20
       bra       User_9
User_11:
; {
; /******************************************************************/
; /*no menu selected / menu exited / menu not displayed*/
; /******************************************************************/
; case MENU_NONE1:
; OsdDisable();
       bsr       _OsdDisable
; menustate=MENU_NONE2;
       move.b    #1,(A2)
; break;
       bra       User_10
User_12:
; case MENU_NONE2:
; if (menu||select)/*check if user wants to go to menu*/
       tst.b     D3
       bne.s     User_28
       tst.b     D2
       beq.s     User_26
User_28:
; {
; menustate=MENU_MAIN1;
       move.b    #2,(A2)
; menusub=0;
       clr.b     _menusub
; OsdClear();
       bsr       _OsdClear
; OsdEnable();
       bsr       _OsdEnable
User_26:
; }
; break;
       bra       User_10
User_13:
; /******************************************************************/
; /*main menu: insert/eject floppy, reset and exit*/
; /******************************************************************/
; case MENU_MAIN1:
; /*menu title*/
; OsdWrite(0," ** Minimig Menu **",0);
       clr.l     -(A7)
       pea       @main_16
       clr.l     -(A7)
       jsr       (A4)
       add.w     #12,A7
; /*df0 info*/
; if (aktdrive==&df0)
       lea       _df0,A0
       move.l    A0,D0
       cmp.l     _aktdrive,D0
       bne.s     User_29
; strcpy(s,"     df0: ");
       pea       @main_17
       move.l    A3,-(A7)
       jsr       (A5)
       addq.w    #8,A7
       bra.s     User_30
User_29:
; else
; strcpy(s,"     df1: ");
       pea       @main_18
       move.l    A3,-(A7)
       jsr       (A5)
       addq.w    #8,A7
User_30:
; if (aktdrive->status&DSK_INSERTED)/*floppy currently in df0*/
       move.l    _aktdrive,A0
       move.b    66(A0),D0
       and.l     #255,D0
       and.l     #1,D0
       beq.s     User_31
; strncpy(&s[10],aktdrive->name,8);
       pea       8
       moveq     #70,D1
       add.l     _aktdrive,D1
       move.l    D1,-(A7)
       move.l    A3,D1
       add.l     #10,D1
       move.l    D1,-(A7)
       bsr       _strncpy
       add.w     #12,A7
       bra.s     User_32
User_31:
; else/*no floppy in df0*/
; strncpy(&s[10],"--------",8);
       pea       8
       pea       @main_19
       move.l    A3,D1
       add.l     #10,D1
       move.l    D1,-(A7)
       bsr       _strncpy
       add.w     #12,A7
User_32:
; s[18]=0x0d;
       move.b    #13,18(A3)
; s[19]=0x00;
       clr.b     19(A3)
; OsdWrite(2,s,0);
       clr.l     -(A7)
       move.l    A3,-(A7)
       pea       2
       jsr       (A4)
       add.w     #12,A7
; if (aktdrive->status&DSK_INSERTED)/*floppy currently in df0*/
       move.l    _aktdrive,A0
       move.b    66(A0),D0
       and.l     #255,D0
       and.l     #1,D0
       beq.s     User_33
; if (aktdrive->status&DSK_WRITABLE)/*floppy is writable*/
       move.l    _aktdrive,A0
       move.b    66(A0),D0
       and.l     #255,D0
       and.l     #2,D0
       beq.s     User_35
; strcpy(s,"     writable ");
       pea       @main_20
       move.l    A3,-(A7)
       jsr       (A5)
       addq.w    #8,A7
       bra.s     User_36
User_35:
; else
; strcpy(s,"     read only");
       pea       @main_21
       move.l    A3,-(A7)
       jsr       (A5)
       addq.w    #8,A7
User_36:
       bra.s     User_34
User_33:
; else    /*no floppy in df0*/
; strcpy(s,"     no disk  ");
       pea       @main_22
       move.l    A3,-(A7)
       jsr       (A5)
       addq.w    #8,A7
User_34:
; OsdWrite(3,s,0);
       clr.l     -(A7)
       move.l    A3,-(A7)
       pea       3
       jsr       (A4)
       add.w     #12,A7
; /*eject/insert df0 options*/
; if (aktdrive->status&DSK_INSERTED)/*floppy currently in df0*/
       move.l    _aktdrive,A0
       move.b    66(A0),D0
       and.l     #255,D0
       and.l     #1,D0
       beq.s     User_37
; strcpy(s,"     eject adf ");
       pea       @main_23
       move.l    A3,-(A7)
       jsr       (A5)
       addq.w    #8,A7
       bra.s     User_38
User_37:
; else/*no floppy in df0*/
; strcpy(s,"     insert adf");
       pea       @main_24
       move.l    A3,-(A7)
       jsr       (A5)
       addq.w    #8,A7
User_38:
; OsdWrite(5,"     settings",menusub==1);
       move.b    _menusub,D1
       and.l     #255,D1
       cmp.l     #1,D1
       bne.s     User_39
       moveq     #1,D1
       bra.s     User_40
User_39:
       clr.l     D1
User_40:
       ext.w     D1
       ext.l     D1
       move.l    D1,-(A7)
       pea       @main_25
       pea       5
       jsr       (A4)
       add.w     #12,A7
; OsdWrite(4,s,menusub==0);
       move.b    _menusub,D1
       and.l     #255,D1
       bne.s     User_41
       moveq     #1,D1
       bra.s     User_42
User_41:
       clr.l     D1
User_42:
       ext.w     D1
       ext.l     D1
       move.l    D1,-(A7)
       move.l    A3,-(A7)
       pea       4
       jsr       (A4)
       add.w     #12,A7
; /*reset system*/
; OsdWrite(6,"     reset",menusub==2);
       move.b    _menusub,D1
       and.l     #255,D1
       cmp.l     #2,D1
       bne.s     User_43
       moveq     #1,D1
       bra.s     User_44
User_43:
       clr.l     D1
User_44:
       ext.w     D1
       ext.l     D1
       move.l    D1,-(A7)
       pea       @main_26
       pea       6
       jsr       (A4)
       add.w     #12,A7
; /*exit menu*/
; OsdWrite(7,"     exit",menusub==3);
       move.b    _menusub,D1
       and.l     #255,D1
       cmp.l     #3,D1
       bne.s     User_45
       moveq     #1,D1
       bra.s     User_46
User_45:
       clr.l     D1
User_46:
       ext.w     D1
       ext.l     D1
       move.l    D1,-(A7)
       pea       @main_27
       pea       7
       jsr       (A4)
       add.w     #12,A7
; OsdEnable();
       bsr       _OsdEnable
; /*goto to second state of main menu*/
; menustate = MENU_MAIN2;
       move.b    #3,(A2)
; break;
       bra       User_10
User_14:
; case MENU_MAIN2:
; if (menu)/*menu pressed*/
       tst.b     D3
       beq.s     User_47
; //							if (aktdrive==&df0)
; //							{	aktdrive=&df1;
; //                                menustate=MENU_MAIN1;
; //							}
; //							else
; //							{	aktdrive=&df0;
; menustate=MENU_NONE1;
       clr.b     (A2)
       bra       User_67
User_47:
; //                            }
; else if (up)/*up pressed*/
       tst.b     D5
       beq.s     User_49
; {
; if (menusub>0)
       move.b    _menusub,D0
       and.l     #255,D0
       cmp.l     #0,D0
       bls.s     User_51
; menusub--;
       subq.b    #1,_menusub
User_51:
; menustate=MENU_MAIN1;
       move.b    #2,(A2)
       bra       User_67
User_49:
; }
; else if (down)/*down pressed*/
       tst.b     D4
       beq.s     User_53
; {
; if (menusub<3)
       move.b    _menusub,D0
       and.l     #255,D0
       cmp.l     #3,D0
       bhs.s     User_55
; menusub++;
       addq.b    #1,_menusub
User_55:
; menustate=MENU_MAIN1;
       move.b    #2,(A2)
       bra       User_67
User_53:
; }
; else if (select)/*select pressed*/
       tst.b     D2
       beq       User_67
; {
; if (menusub==0 && (aktdrive->status&DSK_INSERTED))/*eject floppy*/
       move.b    _menusub,D0
       and.l     #255,D0
       bne.s     User_59
       move.l    _aktdrive,A0
       move.b    66(A0),D0
       and.l     #255,D0
       and.l     #1,D0
       beq.s     User_59
; {
; aktdrive->status = 0;
       move.l    _aktdrive,A0
       clr.b     66(A0)
; menustate = MENU_MAIN1;
       move.b    #2,(A2)
       bra       User_67
User_59:
; }
; else if (menusub==0)/*insert floppy*/
       move.b    _menusub,D0
       and.l     #255,D0
       bne.s     User_61
; {
; aktdrive->status = 0;
       move.l    _aktdrive,A0
       clr.b     66(A0)
; menustate = MENU_FILE1;
       move.b    #4,(A2)
; OsdClear();
       bsr       _OsdClear
       bra       User_67
User_61:
; }
; else if (menusub==1)/*settings*/
       move.b    _menusub,D0
       and.l     #255,D0
       cmp.l     #1,D0
       bne.s     User_63
; {
; menusub = 3;
       move.b    #3,_menusub
; menustate = MENU_SETTINGS1;
       move.b    #8,(A2)
; OsdClear();
       bsr       _OsdClear
       bra.s     User_67
User_63:
; }
; else if (menusub==2)/*reset*/
       move.b    _menusub,D0
       and.l     #255,D0
       cmp.l     #2,D0
       bne.s     User_65
; {
; menusub = 0;
       clr.b     _menusub
; menustate = MENU_RESET1;
       move.b    #6,(A2)
; OsdClear();
       bsr       _OsdClear
       bra.s     User_67
User_65:
; }
; else if (menusub==3)/*exit menu*/
       move.b    _menusub,D0
       and.l     #255,D0
       cmp.l     #3,D0
       bne.s     User_67
; menustate = MENU_NONE1;
       clr.b     (A2)
User_67:
; }
; break;
       bra       User_10
User_15:
; /******************************************************************/
; /*adf file requester menu*/
; /******************************************************************/
; case MENU_FILE1:
; PrintDir();
       bsr       _PrintDir
; menustate=MENU_FILE2;
       move.b    #5,(A2)
; break;
       bra       User_10
User_16:
; case MENU_FILE2:
; if (down)/*scroll down through file requester*/
       tst.b     D4
       beq       User_69
; {
; if (dirptr == DIRSIZE-1)/*pointer is at bottom of directory window*/
       move.b    _dirptr,D0
       and.l     #255,D0
       cmp.l     #7,D0
       bne       User_71
; {		first_dir_entry++;
       addq.w    #1,_first_dir_entry
; ReadDir("ADF",first_dir_entry);
       move.w    _first_dir_entry,D1
       and.l     #65535,D1
       move.l    D1,-(A7)
       pea       @main_28
       bsr       _ReadDir
       addq.w    #8,A7
; if (directory[dirptr].len==0)
       move.b    _dirptr,D0
       and.l     #255,D0
       muls      #26,D0
       lea       _directory,A0
       add.l     D0,A0
       move.l    18(A0),D0
       bne.s     User_73
; {	first_dir_entry--;
       subq.w    #1,_first_dir_entry
; ReadDir("ADF",first_dir_entry);
       move.w    _first_dir_entry,D1
       and.l     #65535,D1
       move.l    D1,-(A7)
       pea       @main_29
       bsr       _ReadDir
       addq.w    #8,A7
User_73:
       bra.s     User_75
User_71:
; }
; }
; else/*just move pointer in window*/
; {
; if (directory[dirptr+1].len!=0)
       moveq     #1,D0
       move.b    _dirptr,D1
       and.l     #255,D1
       add.l     D1,D0
       muls      #26,D0
       lea       _directory,A0
       add.l     D0,A0
       move.l    18(A0),D0
       beq.s     User_75
; dirptr++;
       addq.b    #1,_dirptr
User_75:
; }
; menustate=MENU_FILE1;
       move.b    #4,(A2)
User_69:
; }
; if (up)/*scroll up through file requester*/
       tst.b     D5
       beq       User_77
; {
; if (dirptr==0)/*pointer is at top of directory window*/
       move.b    _dirptr,D0
       and.l     #255,D0
       bne.s     User_79
; {
; if (first_dir_entry>0)
       move.w    _first_dir_entry,D0
       and.l     #65535,D0
       cmp.l     #0,D0
       bls.s     User_81
; {	first_dir_entry--;
       subq.w    #1,_first_dir_entry
; ReadDir("ADF",first_dir_entry);
       move.w    _first_dir_entry,D1
       and.l     #65535,D1
       move.l    D1,-(A7)
       pea       @main_30
       bsr       _ReadDir
       addq.w    #8,A7
User_81:
       bra.s     User_80
User_79:
; }
; }
; else
; dirptr--;
       subq.b    #1,_dirptr
User_80:
; menustate=MENU_FILE1;
       move.b    #4,(A2)
User_77:
; }
; if (select)/*insert floppy*/
       tst.b     D2
       beq.s     User_83
; {
; menustate = MENU_MAIN1;
       move.b    #2,(A2)
; //                                menusub = 3;
; OsdClear();
       bsr       _OsdClear
; //                                if (directory[dirptr].len)
; //                                {
; file = directory[dirptr];
       lea       _file,A0
       lea       _directory,A1
       move.b    _dirptr,D0
       and.l     #255,D0
       muls      #26,D0
       add.l     D0,A1
       moveq     #12,D0
User_85:
       move.w    (A1)+,(A0)+
       dbra      D0,User_85
; menustate = MENU_NONE1;
       clr.b     (A2)
; InsertFloppy(aktdrive);
       move.l    _aktdrive,-(A7)
       bsr       _InsertFloppy
       addq.w    #4,A7
User_83:
; //                                }
; }
; if (menu)/*return to main menu*/
       tst.b     D3
       beq.s     User_86
; {
; menustate = MENU_MAIN1;
       move.b    #2,(A2)
; menusub = 0;
       clr.b     _menusub
; OsdClear();
       bsr       _OsdClear
User_86:
; }
; break;
       bra       User_10
User_17:
; /******************************************************************/
; /*reset menu*/
; /******************************************************************/
; case MENU_RESET1:
; /*menu title*/
; OsdWrite(0,"    Reset Minimig?",0);
       clr.l     -(A7)
       pea       @main_31
       clr.l     -(A7)
       jsr       (A4)
       add.w     #12,A7
; OsdWrite(2,"      yes",menusub==0);
       move.b    _menusub,D1
       and.l     #255,D1
       bne.s     User_88
       moveq     #1,D1
       bra.s     User_89
User_88:
       clr.l     D1
User_89:
       ext.w     D1
       ext.l     D1
       move.l    D1,-(A7)
       pea       @main_32
       pea       2
       jsr       (A4)
       add.w     #12,A7
; OsdWrite(3,"      no",menusub==1);
       move.b    _menusub,D1
       and.l     #255,D1
       cmp.l     #1,D1
       bne.s     User_90
       moveq     #1,D1
       bra.s     User_91
User_90:
       clr.l     D1
User_91:
       ext.w     D1
       ext.l     D1
       move.l    D1,-(A7)
       pea       @main_33
       pea       3
       jsr       (A4)
       add.w     #12,A7
; /*goto to second state of reset menu*/
; menustate = MENU_RESET2;
       move.b    #7,(A2)
; break;
       bra       User_10
User_18:
; case MENU_RESET2:
; if (down && menusub<1)
       tst.b     D4
       beq.s     User_92
       move.b    _menusub,D0
       and.l     #255,D0
       cmp.l     #1,D0
       bhs.s     User_92
; {
; menusub++;
       addq.b    #1,_menusub
; menustate = MENU_RESET1;
       move.b    #6,(A2)
User_92:
; }
; if (up && menusub>0)
       tst.b     D5
       beq.s     User_94
       move.b    _menusub,D0
       and.l     #255,D0
       cmp.l     #0,D0
       bls.s     User_94
; {
; menusub--;
       subq.b    #1,_menusub
; menustate = MENU_RESET1;
       move.b    #6,(A2)
User_94:
; }
; if (select)
       tst.b     D2
       beq.s     User_98
; {
; if (menusub==0)
       move.b    _menusub,D0
       and.l     #255,D0
       bne.s     User_98
; {
; OsdReset(0);
       clr.l     -(A7)
       bsr       _OsdReset
       addq.w    #4,A7
; menustate = MENU_NONE1;
       clr.b     (A2)
User_98:
; }
; }
; if (menu || (select && menusub==1))/*exit menu*/
       tst.b     D3
       bne.s     User_102
       tst.b     D2
       beq.s     User_100
       move.b    _menusub,D0
       and.l     #255,D0
       cmp.l     #1,D0
       bne.s     User_100
User_102:
; {
; menustate = MENU_MAIN1;
       move.b    #2,(A2)
; menusub = 2;
       move.b    #2,_menusub
; OsdClear();
       bsr       _OsdClear
User_100:
; }
; break;
       bra       User_10
User_19:
; //                /******************************************************************/
; //                /*settings menu*/
; //                /******************************************************************/
; case MENU_SETTINGS1:
; /*menu title*/
; OsdWrite(0,"   ** SETTINGS **",0);
       clr.l     -(A7)
       pea       @main_34
       clr.l     -(A7)
       jsr       (A4)
       add.w     #12,A7
; strcpy(s,"  Lores Filter: ");
       pea       @main_35
       move.l    A3,-(A7)
       jsr       (A5)
       addq.w    #8,A7
; strcpy(&s[16],filter_msg[lr_filter]);
       move.b    _lr_filter,D1
       and.l     #255,D1
       lsl.l     #2,D1
       lea       _filter_msg,A0
       move.l    0(A0,D1.L),-(A7)
       move.l    A3,D1
       add.l     #16,D1
       move.l    D1,-(A7)
       jsr       (A5)
       addq.w    #8,A7
; OsdWrite(2,s,menusub==0);
       move.b    _menusub,D1
       and.l     #255,D1
       bne.s     User_103
       moveq     #1,D1
       bra.s     User_104
User_103:
       clr.l     D1
User_104:
       ext.w     D1
       ext.l     D1
       move.l    D1,-(A7)
       move.l    A3,-(A7)
       pea       2
       jsr       (A4)
       add.w     #12,A7
; strcpy(s,"  Hires Filter: ");
       pea       @main_36
       move.l    A3,-(A7)
       jsr       (A5)
       addq.w    #8,A7
; strcpy(&s[16],filter_msg[hr_filter]);
       move.b    _hr_filter,D1
       and.l     #255,D1
       lsl.l     #2,D1
       lea       _filter_msg,A0
       move.l    0(A0,D1.L),-(A7)
       move.l    A3,D1
       add.l     #16,D1
       move.l    D1,-(A7)
       jsr       (A5)
       addq.w    #8,A7
; OsdWrite(3,s,menusub==1);
       move.b    _menusub,D1
       and.l     #255,D1
       cmp.l     #1,D1
       bne.s     User_105
       moveq     #1,D1
       bra.s     User_106
User_105:
       clr.l     D1
User_106:
       ext.w     D1
       ext.l     D1
       move.l    D1,-(A7)
       move.l    A3,-(A7)
       pea       3
       jsr       (A4)
       add.w     #12,A7
; strcpy(s,"  RAM: ");
       pea       @main_37
       move.l    A3,-(A7)
       jsr       (A5)
       addq.w    #8,A7
; strcpy(&s[7],memcfg_msg[memcfg]);
       move.b    _memcfg,D1
       and.l     #255,D1
       lsl.l     #2,D1
       lea       _memcfg_msg,A0
       move.l    0(A0,D1.L),-(A7)
       move.l    A3,D1
       addq.l    #7,D1
       move.l    D1,-(A7)
       jsr       (A5)
       addq.w    #8,A7
; OsdWrite(4,s,menusub==2);
       move.b    _menusub,D1
       and.l     #255,D1
       cmp.l     #2,D1
       bne.s     User_107
       moveq     #1,D1
       bra.s     User_108
User_107:
       clr.l     D1
User_108:
       ext.w     D1
       ext.l     D1
       move.l    D1,-(A7)
       move.l    A3,-(A7)
       pea       4
       jsr       (A4)
       add.w     #12,A7
; OsdWrite(7,"        exit",menusub==3);
       move.b    _menusub,D1
       and.l     #255,D1
       cmp.l     #3,D1
       bne.s     User_109
       moveq     #1,D1
       bra.s     User_110
User_109:
       clr.l     D1
User_110:
       ext.w     D1
       ext.l     D1
       move.l    D1,-(A7)
       pea       @main_38
       pea       7
       jsr       (A4)
       add.w     #12,A7
; /*goto to second state of reset menu*/
; menustate = MENU_SETTINGS2;
       move.b    #9,(A2)
; break;
       bra       User_10
User_20:
; case MENU_SETTINGS2:
; if (down && menusub<3)
       tst.b     D4
       beq.s     User_111
       move.b    _menusub,D0
       and.l     #255,D0
       cmp.l     #3,D0
       bhs.s     User_111
; {
; menusub++;
       addq.b    #1,_menusub
; menustate = MENU_SETTINGS1;
       move.b    #8,(A2)
User_111:
; }
; if (up && menusub>0)
       tst.b     D5
       beq.s     User_113
       move.b    _menusub,D0
       and.l     #255,D0
       cmp.l     #0,D0
       bls.s     User_113
; {
; menusub--;
       subq.b    #1,_menusub
; menustate = MENU_SETTINGS1;
       move.b    #8,(A2)
User_113:
; }
; if (select)
       tst.b     D2
       beq       User_121
; {
; if (menusub==0)
       move.b    _menusub,D0
       and.l     #255,D0
       bne.s     User_117
; {
; lr_filter++;
       addq.b    #1,_lr_filter
; lr_filter &= 0x03;
       and.b     #3,_lr_filter
; menustate = MENU_SETTINGS1;
       move.b    #8,(A2)
; OsdFilter(lr_filter,hr_filter);
       move.b    _hr_filter,D1
       and.l     #255,D1
       move.l    D1,-(A7)
       move.b    _lr_filter,D1
       and.l     #255,D1
       move.l    D1,-(A7)
       bsr       _OsdFilter
       addq.w    #8,A7
       bra       User_121
User_117:
; }
; else if (menusub==1)
       move.b    _menusub,D0
       and.l     #255,D0
       cmp.l     #1,D0
       bne.s     User_119
; {
; hr_filter++;
       addq.b    #1,_hr_filter
; hr_filter &= 0x03;
       and.b     #3,_hr_filter
; menustate = MENU_SETTINGS1;
       move.b    #8,(A2)
; OsdFilter(lr_filter,hr_filter);
       move.b    _hr_filter,D1
       and.l     #255,D1
       move.l    D1,-(A7)
       move.b    _lr_filter,D1
       and.l     #255,D1
       move.l    D1,-(A7)
       bsr       _OsdFilter
       addq.w    #8,A7
       bra.s     User_121
User_119:
; }
; else if (menusub==2)
       move.b    _menusub,D0
       and.l     #255,D0
       cmp.l     #2,D0
       bne.s     User_121
; {
; memcfg++;
       addq.b    #1,_memcfg
; memcfg &= 0x03;
       and.b     #3,_memcfg
; menustate = MENU_SETTINGS1;
       move.b    #8,(A2)
; OsdMemoryConfig(memcfg);
       move.b    _memcfg,D1
       and.l     #255,D1
       move.l    D1,-(A7)
       bsr       _OsdMemoryConfig
       addq.w    #4,A7
User_121:
; }
; }
; if (menu || (select && menusub==3)) /*return to main menu*/
       tst.b     D3
       bne.s     User_125
       tst.b     D2
       beq.s     User_123
       move.b    _menusub,D0
       and.l     #255,D0
       cmp.l     #3,D0
       bne.s     User_123
User_125:
; {
; menustate = MENU_MAIN1;
       move.b    #2,(A2)
; menusub = 1;
       move.b    #1,_menusub
; OsdClear();
       bsr       _OsdClear
User_123:
; }
; break;
       bra.s     User_10
User_21:
; /******************************************************************/
; /*error message menu*/
; /******************************************************************/
; case MENU_ERROR:
; if (menu||select) /*exit when menu button is pressed*/
       tst.b     D3
       bne.s     User_128
       tst.b     D2
       beq.s     User_126
User_128:
; {
; menustate = MENU_NONE1;
       clr.b     (A2)
User_126:
; }
; break;
       bra.s     User_10
User_9:
; /******************************************************************/
; /*we should never come here*/
; /******************************************************************/
; default:
; menustate = MENU_MAIN1;
       move.b    #2,(A2)
; break;
User_10:
       movem.l   (A7)+,D2/D3/D4/D5/D6/A2/A3/A4/A5
       rts
; }
; }
; void ErrorMessage(const char* message, unsigned char code)
; {
       xdef      _ErrorMessage
_ErrorMessage:
       link      A6,#0
       movem.l   D2/A2/A3,-(A7)
       lea       _s,A2
       move.b    15(A6),D2
       and.l     #255,D2
       lea       _OsdWrite,A3
; menustate = MENU_ERROR;
       move.b    #127,_menustate
; OsdClear();
       bsr       _OsdClear
; OsdWrite(0,"    *** ERROR ***",1);
       pea       1
       pea       @main_39
       clr.l     -(A7)
       jsr       (A3)
       add.w     #12,A7
; strncpy(s,message,21);
       pea       21
       move.l    8(A6),-(A7)
       move.l    A2,-(A7)
       bsr       _strncpy
       add.w     #12,A7
; s[21] = 0;
       clr.b     21(A2)
; OsdWrite(2,s,0);
       clr.l     -(A7)
       move.l    A2,-(A7)
       pea       2
       jsr       (A3)
       add.w     #12,A7
; if (code)
       tst.b     D2
       beq       ErrorMessage_1
; {
; strcpy(s,"  error #     ");
       pea       @main_40
       move.l    A2,-(A7)
       bsr       _strcpy
       addq.w    #8,A7
; s[9]=code/10+0x30;
       moveq     #48,D0
       move.b    D2,D1
       divu.w    #10,D1
       and.l     #255,D1
       add.l     D1,D0
       move.b    D0,9(A2)
; s[10]=code%10+0x30;
       moveq     #48,D0
       move.b    D2,D1
       divu.w    #10,D1
       swap      D1
       and.l     #255,D1
       add.l     D1,D0
       move.b    D0,10(A2)
; OsdWrite(4,s,0);
       clr.l     -(A7)
       move.l    A2,-(A7)
       pea       4
       jsr       (A3)
       add.w     #12,A7
ErrorMessage_1:
; }
; OsdEnable();
       bsr       _OsdEnable
       movem.l   (A7)+,D2/A2/A3
       unlk      A6
       rts
; }
; /*print the contents of directory[] and the pointer dirptr onto the OSD*/
; void PrintDir(void)
; {
       xdef      _PrintDir
_PrintDir:
       movem.l   D2/A2,-(A7)
       lea       _s,A2
; unsigned char i;
; for(i=0;i<21;i++)
       clr.b     D2
PrintDir_1:
       and.l     #255,D2
       cmp.l     #21,D2
       bhs.s     PrintDir_3
; s[i] = ' ';
       and.l     #255,D2
       move.b    #32,0(A2,D2.L)
       addq.b    #1,D2
       bra       PrintDir_1
PrintDir_3:
; s[21] = 0;
       clr.b     21(A2)
; if (directory[0].len==0)
       move.l    _directory+18,D0
       bne.s     PrintDir_4
; OsdWrite(1,"   No files!",1);
       pea       1
       pea       @main_41
       pea       1
       bsr       _OsdWrite
       add.w     #12,A7
       bra       PrintDir_8
PrintDir_4:
; else
; for(i=0;i<DIRSIZE;i++)
       clr.b     D2
PrintDir_6:
       and.l     #255,D2
       cmp.l     #8,D2
       bhs       PrintDir_8
; {
; strncpy(&s[3],directory[i].name,8);
       pea       8
       lea       _directory,A0
       and.l     #255,D2
       move.l    D2,D1
       muls      #26,D1
       add.l     D1,A0
       move.l    A0,-(A7)
       move.l    A2,D1
       addq.l    #3,D1
       move.l    D1,-(A7)
       bsr       _strncpy
       add.w     #12,A7
; OsdWrite(i,s,i==dirptr);
       cmp.b     _dirptr,D2
       bne.s     PrintDir_9
       moveq     #1,D1
       bra.s     PrintDir_10
PrintDir_9:
       clr.l     D1
PrintDir_10:
       ext.w     D1
       ext.l     D1
       move.l    D1,-(A7)
       move.l    A2,-(A7)
       and.l     #255,D2
       move.l    D2,-(A7)
       bsr       _OsdWrite
       add.w     #12,A7
       addq.b    #1,D2
       bra       PrintDir_6
PrintDir_8:
       movem.l   (A7)+,D2/A2
       rts
; }
; }
; /*insert floppy image pointed to to by global <file> into <drive>*/
; void InsertFloppy(struct adfTYPE *drive)
; {
       xdef      _InsertFloppy
_InsertFloppy:
       link      A6,#0
       movem.l   D2/D3/A2,-(A7)
       move.l    8(A6),D2
       lea       _file,A2
; unsigned char i;
; drive->entries=MOUNT_ENTRIES;
       move.l    D2,A0
       move.w    #8,(A0)
; drive->fragment[1]=file.cluster;
       move.l    D2,A0
       move.l    22(A2),6(A0)
; if (MountFile(drive))
       move.l    D2,-(A7)
       bsr       _MountFile
       addq.w    #4,A7
       tst.l     D0
       beq.s     InsertFloppy_1
; drive->status = DSK_INSERTED;
       move.l    D2,A0
       move.b    #1,66(A0)
       bra.s     InsertFloppy_2
InsertFloppy_1:
; else
; ErrorMessage("more then 8 fragments",0);
       clr.l     -(A7)
       pea       @main_42
       bsr       _ErrorMessage
       addq.w    #8,A7
InsertFloppy_2:
; /*copy name*/
; for(i=0;i<12;i++)
       clr.b     D3
InsertFloppy_3:
       and.l     #255,D3
       cmp.l     #12,D3
       bhs.s     InsertFloppy_5
; drive->name[i]=file.name[i];
       and.l     #255,D3
       move.l    D2,A0
       and.l     #255,D3
       add.l     D3,A0
       move.b    0(A2,D3.L),70(A0)
       addq.b    #1,D3
       bra       InsertFloppy_3
InsertFloppy_5:
; /*initialize rest of struct*/
; if (!(file.attributes&0x01))/*read-only attribute*/
       move.b    12(A2),D0
       and.l     #255,D0
       and.l     #1,D0
       bne.s     InsertFloppy_6
; drive->status |= DSK_WRITABLE;
       move.l    D2,A0
       or.b      #2,66(A0)
InsertFloppy_6:
; drive->sectoroffset=0;
       move.l    D2,A0
       clr.b     67(A0)
; drive->track=0;
       move.l    D2,A0
       clr.b     68(A0)
; drive->trackprev=-1;
       move.l    D2,A0
       move.b    #255,69(A0)
       movem.l   (A7)+,D2/D3/A2
       unlk      A6
       rts
; //      puts("Inserting floppy: ");
; //		puts(&file.name[0]);
; }
; /*Handle an FPGA command*/
; void HandleFpgaCmd(unsigned char c1, unsigned char c2)
; {
       xdef      _HandleFpgaCmd
_HandleFpgaCmd:
       link      A6,#-4
       movem.l   A2,-(A7)
       lea       _seldrive,A2
; unsigned short sel;
; sel=OSD(0);
       clr.l     -(A7)
       bsr       _OSD
       addq.w    #4,A7
       move.w    D0,-2(A6)
; seldrive=&df0;
       lea       _df0,A0
       move.l    A0,(A2)
; //	if (!(sel&0x0800))
; //	{	seldrive=&df0;putch('0');}
; //	if (!(sel&0x1000))
; //	{	seldrive=&df1;putch('1');}
; //	if (!(sel&0x2000))
; //	{	seldrive=&df2;putch('2');}
; //	if (!(sel&0x4000))
; //	{	seldrive=&df3;putch('3');}
; /*c1 is command byte*/
; switch(c1&(CMD_GETDSKSTAT|CMD_RDTRCK|CMD_WRTRCK))
       move.b    11(A6),D0
       and.l     #255,D0
       and.l     #7,D0
       cmp.l     #2,D0
       beq.s     HandleFpgaCmd_4
       bgt.s     HandleFpgaCmd_7
       cmp.l     #1,D0
       beq.s     HandleFpgaCmd_5
       bra       HandleFpgaCmd_1
HandleFpgaCmd_7:
       cmp.l     #4,D0
       beq.s     HandleFpgaCmd_3
       bra       HandleFpgaCmd_1
HandleFpgaCmd_3:
; {
; /*FPGA is requesting track status*/
; case CMD_GETDSKSTAT:
; CheckTrack(seldrive);
       move.l    (A2),-(A7)
       bsr       _CheckTrack
       addq.w    #4,A7
; break;
       bra.s     HandleFpgaCmd_2
HandleFpgaCmd_4:
; /*FPGA wants to read a track
; c2 is track number*/
; case CMD_RDTRCK:
; seldrive->track=c2;
       move.l    (A2),A0
       move.b    15(A6),68(A0)
; /*                      DISKLED=1;
; */                      ReadTrack(seldrive);
       move.l    (A2),-(A7)
       bsr       _ReadTrack
       addq.w    #4,A7
; /*                      DISKLED=0;
; */                      break;
       bra.s     HandleFpgaCmd_2
HandleFpgaCmd_5:
; /*FPGA wants to write a track
; c2 is track number*/
; case CMD_WRTRCK:
; seldrive->track=c2;
       move.l    (A2),A0
       move.b    15(A6),68(A0)
; /*                      DISKLED=1;
; */                      WriteTrack(seldrive);
       move.l    (A2),-(A7)
       bsr       _WriteTrack
       addq.w    #4,A7
; /*                      DISKLED=0;
; */                      break;
       bra       HandleFpgaCmd_2
HandleFpgaCmd_1:
; /*no command*/
; default:
; break;
HandleFpgaCmd_2:
       movem.l   (A7)+,A2
       unlk      A6
       rts
; }
; }
; /*CheckTrack, respond with disk status*/
; void CheckTrack(struct adfTYPE *drive)
; {
       xdef      _CheckTrack
_CheckTrack:
       link      A6,#0
       movem.l   A2,-(A7)
       lea       _SPI,A2
; EnableFpga();
       bsr       _EnableFpga
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x00);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
; SPI(drive->status);
       move.l    8(A6),A0
       move.b    66(A0),D1
       and.l     #255,D1
       move.l    D1,-(A7)
       jsr       (A2)
       addq.w    #4,A7
; DisableFpga();
       bsr       _DisableFpga
       movem.l   (A7)+,A2
       unlk      A6
       rts
; }
; /*read a track from disk*/
; void ReadTrack(struct adfTYPE *drive)
; {       /*track number is updated in drive struct before calling this function*/
       xdef      _ReadTrack
_ReadTrack:
       link      A6,#-4
       movem.l   D2/D3/D4/D5/D6/D7/A2/A3,-(A7)
       move.l    8(A6),D2
       lea       _SPI,A2
       lea       _file,A3
; unsigned char sector;
; unsigned char c1,c2,c3,c4;
; unsigned short n;
; /*display track number: cylinder & head*/
; /*#ifdef DEBUG
; puts("*%d:",drive->track);
; #endif
; */
; if (drive->track != drive->trackprev)
       move.l    D2,A0
       move.l    D2,A1
       move.b    68(A0),D0
       cmp.b     69(A1),D0
       beq.s     ReadTrack_1
; {/*track step or track 0, start at beginning of track*/
; drive->trackprev = drive->track;
       move.l    D2,A0
       move.l    D2,A1
       move.b    68(A0),69(A1)
; sector           = 0;
       clr.b     D3
; file.sec         = drive->track*11;
       move.l    D2,A0
       move.b    68(A0),D0
       and.w     #255,D0
       mulu.w    #11,D0
       and.l     #65535,D0
       move.w    D0,16(A3)
; drive->sectoroffset = sector;
       move.l    D2,A0
       move.b    D3,67(A0)
       bra.s     ReadTrack_2
ReadTrack_1:
; }
; else
; {/*same track, start at next sector in track*/
; sector       = drive->sectoroffset;
       move.l    D2,A0
       move.b    67(A0),D3
; file.sec     = (drive->track*11)+sector;
       move.l    D2,A0
       move.b    68(A0),D0
       and.w     #255,D0
       mulu.w    #11,D0
       and.l     #65535,D0
       and.l     #255,D3
       add.l     D3,D0
       move.w    D0,16(A3)
ReadTrack_2:
; }
; EnableFpga();
       bsr       _EnableFpga
; c1 = SPI(0);            /*read request signal*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,-1(A6)
; c2 = SPI(0);            /*track number (cylinder & head)*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D7
; c3 = 0x3F&SPI(0);       /*msb of mfm words to transfer */
       moveq     #63,D0
       move.l    D0,-(A7)
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.l    D0,D1
       move.l    (A7)+,D0
       and.l     D1,D0
       move.b    D0,D5
; c4 = SPI(drive->status);                /*lsb of mfm words to transfer*/
       move.l    D2,A0
       move.b    66(A0),D1
       and.l     #255,D1
       move.l    D1,-(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D4
; DisableFpga();
       bsr       _DisableFpga
; /* if dma read count is bigger than 11 sectors then we start the transfer from the begining of current track*/
; if ((c3>0x17) || (c3==0x17 && c4>=0x60))
       and.l     #255,D5
       cmp.l     #23,D5
       bhi.s     ReadTrack_5
       and.l     #255,D5
       cmp.l     #23,D5
       bne.s     ReadTrack_3
       and.l     #255,D4
       cmp.l     #96,D4
       blo.s     ReadTrack_3
ReadTrack_5:
; {
; sector           = 0;
       clr.b     D3
; file.sec         = drive->track*11;
       move.l    D2,A0
       move.b    68(A0),D0
       and.w     #255,D0
       mulu.w    #11,D0
       and.l     #65535,D0
       move.w    D0,16(A3)
ReadTrack_3:
; }
; while (1)
ReadTrack_6:
; {
; SectorRead(drive, file.sec);
       move.w    16(A3),D1
       and.l     #65535,D1
       move.l    D1,-(A7)
       move.l    D2,-(A7)
       bsr       _SectorRead
       addq.w    #8,A7
; EnableFpga();
       bsr       _EnableFpga
; /*check if FPGA is still asking for data*/
; c1 = SPI(0);    /*read request signal*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,-1(A6)
; c2 = SPI(0);    /*track number (cylinder & head)*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D7
; c3 = SPI(0);    /*msb of mfm words to transfer*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D5
; c4 = SPI(drive->status);        /*lsb of mfm words to transfer*/
       move.l    D2,A0
       move.b    66(A0),D1
       and.l     #255,D1
       move.l    D1,-(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D4
; /*      #ifdef DEBUG
; c = sector + '0';
; if (c>'9')
; c += 'A'-'9'-1;
; putchar(c);
; putchar(':');
; c = ((c3>>4)&0xF) + '0';
; if (c>'9')
; c += 'A'-'9'-1;
; putchar(c);
; c = (c3&0xF) + '0';
; if (c>'9')
; c += 'A'-'9'-1;
; putchar(c);
; c = ((c4>>4)&0xF) + '0';
; if (c>'9')
; c += 'A'-'9'-1;
; putchar(c);
; c = (c4&0xF) + '0';
; if (c>'9')
; c += 'A'-'9'-1;
; putchar(c);
; #endif
; */
; c3 &= 0x3F;
       and.b     #63,D5
; /*some loaders stop dma if sector header isn't what they expect
; we don't check dma transfer count after sending every word
; so the track can be changed while we are sending the rest of the previous sector
; in this case let's start transfer from the beginning*/
; if (c2 == drive->track)
       move.l    D2,A0
       cmp.b     68(A0),D7
       bne       ReadTrack_17
; /*send sector if fpga is still asking for data*/
; if (c1&0x02)
       move.b    -1(A6),D0
       and.l     #255,D0
       and.l     #2,D0
       beq       ReadTrack_17
; {
; if (c3==0 && c4<4)
       and.l     #255,D5
       bne.s     ReadTrack_13
       and.l     #255,D4
       cmp.l     #4,D4
       bhs.s     ReadTrack_13
; SectorHeaderToFpga(c4);
       and.l     #255,D4
       move.l    D4,-(A7)
       bsr       _SectorHeaderToFpga
       addq.w    #4,A7
       bra       ReadTrack_17
ReadTrack_13:
; else
; {
; n = SectorToFpga(sector,drive->track);
       move.l    D2,A0
       move.b    68(A0),D1
       and.l     #255,D1
       move.l    D1,-(A7)
       and.l     #255,D3
       move.l    D3,-(A7)
       bsr       _SectorToFpga
       addq.w    #8,A7
       move.w    D0,D6
; /*                      #ifdef DEBUG    */                              /* printing remaining dma count */
; /*                              putchar('-');
; c = ((n>>12)&0xF) + '0';
; if (c>'9')
; c += 'A'-'9'-1;
; putchar(c);
; c = ((n>>8)&0xF) + '0';
; if (c>'9')
; c += 'A'-'9'-1;
; putchar(c);
; c = ((n>>4)&0xF) + '0';
; if (c>'9')
; c += 'A'-'9'-1;
; putchar(c);
; c = (n&0xF) + '0';
; if (c>'9')
; c += 'A'-'9'-1;
; putchar(c);
; #endif
; */
; n--;
       subq.w    #1,D6
; c3 = (n>>8)&0x3F;
       and.l     #65535,D6
       move.l    D6,D0
       lsr.l     #8,D0
       and.l     #63,D0
       move.b    D0,D5
; c4 = n;
       move.b    D6,D4
; if (c3==0 && c4<4)
       and.l     #255,D5
       bne.s     ReadTrack_15
       and.l     #255,D4
       cmp.l     #4,D4
       bhs.s     ReadTrack_15
; {
; SectorHeaderToFpga(c4);
       and.l     #255,D4
       move.l    D4,-(A7)
       bsr       _SectorHeaderToFpga
       addq.w    #4,A7
       bra.s     ReadTrack_17
ReadTrack_15:
; /*                              #ifdef DEBUG
; putchar('+');
; c4 += '0';
; putchar(c4);
; #endif
; */                              }
; else
; if (sector==10)
       and.l     #255,D3
       cmp.l     #10,D3
       bne.s     ReadTrack_17
; {
; SectorGapToFpga();
       bsr       _SectorGapToFpga
ReadTrack_17:
; /*                              #ifdef DEBUG
; putchar('+');
; putchar('+');
; putchar('+');
; #endif
; */                              }
; }
; }
; /*we are done accessing FPGA*/
; DisableFpga();
       bsr       _DisableFpga
; /*track has changed*/
; if (c2 != drive->track)
       move.l    D2,A0
       cmp.b     68(A0),D7
       beq.s     ReadTrack_19
; break;
       bra       ReadTrack_8
ReadTrack_19:
; /*read dma request*/
; if (!(c1&0x02))
       move.b    -1(A6),D0
       and.l     #255,D0
       and.l     #2,D0
       bne.s     ReadTrack_21
; break;
       bra       ReadTrack_8
ReadTrack_21:
; /*don't go to the next sector if there is not enough data in the fifo*/
; if (c3==0 && c4<4)
       and.l     #255,D5
       bne.s     ReadTrack_23
       and.l     #255,D4
       cmp.l     #4,D4
       bhs.s     ReadTrack_23
; break;
       bra       ReadTrack_8
ReadTrack_23:
; /* go to the next sector*/
; sector++;
       addq.b    #1,D3
; if (sector<11)
       and.l     #255,D3
       cmp.l     #11,D3
       bhs.s     ReadTrack_25
; {
; file.sec++;
       move.l    A3,D0
       add.l     #16,D0
       move.l    D0,A0
       addq.w    #1,(A0)
       bra.s     ReadTrack_26
ReadTrack_25:
; }
; else    /*go to the start of current track*/
; {
; sector       = 0;
       clr.b     D3
; file.sec     = drive->track*11;
       move.l    D2,A0
       move.b    68(A0),D0
       and.w     #255,D0
       mulu.w    #11,D0
       and.l     #65535,D0
       move.w    D0,16(A3)
ReadTrack_26:
; }
; /*remember current sector and cluster*/
; drive->sectoroffset  = sector;
       move.l    D2,A0
       move.b    D3,67(A0)
       bra       ReadTrack_6
ReadTrack_8:
       movem.l   (A7)+,D2/D3/D4/D5/D6/D7/A2/A3
       unlk      A6
       rts
; /*      #ifdef DEBUG
; putchar('-');
; putchar('>');
; #endif
; */
; }
; /*#ifdef DEBUG
; putchar(':');
; putchar('O');
; putchar('K');
; putchar('\r');
; #endif
; */
; }
; void WriteTrack(struct adfTYPE *drive)
; {
       xdef      _WriteTrack
_WriteTrack:
       link      A6,#-4
       movem.l   D2/D3/A2,-(A7)
       move.l    8(A6),D2
       lea       _file,A2
; unsigned char sector;
; unsigned char Track;
; unsigned char Sector;
; /*setting file pointer to begining of current track*/
; file.sec     = drive->track*11;
       move.l    D2,A0
       move.b    68(A0),D0
       and.w     #255,D0
       mulu.w    #11,D0
       and.l     #65535,D0
       move.w    D0,16(A2)
; sector = 0;
       clr.b     D3
; drive->trackprev = drive->track+1;      /*just to force next read from the start of current track*/
       moveq     #1,D0
       move.l    D2,A0
       move.b    68(A0),D1
       and.l     #255,D1
       add.l     D1,D0
       move.l    D2,A0
       move.b    D0,69(A0)
; /*#ifdef DEBUG
; puts("*%d:\r",drive->track);
; #endif
; */
; while (FindSync(drive))
WriteTrack_1:
       move.l    D2,-(A7)
       bsr       _FindSync
       addq.w    #4,A7
       tst.b     D0
       beq       WriteTrack_3
; {
; if (GetHeader(&Track,&Sector))
       pea       -1(A6)
       pea       -2(A6)
       bsr       _GetHeader
       addq.w    #8,A7
       tst.b     D0
       beq       WriteTrack_7
; {
; if (Track == drive->track)
       move.l    D2,A0
       move.b    -2(A6),D0
       cmp.b     68(A0),D0
       bne       WriteTrack_6
; {
; while (sector != Sector)
WriteTrack_8:
       cmp.b     -1(A6),D3
       beq       WriteTrack_10
; {
; if (sector < Sector)
       cmp.b     -1(A6),D3
       bhs.s     WriteTrack_11
; {
; file.sec++;
       move.l    A2,D0
       add.l     #16,D0
       move.l    D0,A0
       addq.w    #1,(A0)
; sector++;
       addq.b    #1,D3
       bra.s     WriteTrack_12
WriteTrack_11:
; }
; else
; {
; file.sec     = drive->track*11;
       move.l    D2,A0
       move.b    68(A0),D0
       and.w     #255,D0
       mulu.w    #11,D0
       and.l     #65535,D0
       move.w    D0,16(A2)
; sector = 0;
       clr.b     D3
WriteTrack_12:
       bra       WriteTrack_8
WriteTrack_10:
; }
; }
; if (GetData())
       bsr       _GetData
       tst.b     D0
       beq.s     WriteTrack_16
; {
; if (drive->status&DSK_WRITABLE)
       move.l    D2,A0
       move.b    66(A0),D0
       and.l     #255,D0
       and.l     #2,D0
       beq.s     WriteTrack_15
; SectorWrite(drive, file.sec);
       move.w    16(A2),D1
       and.l     #65535,D1
       move.l    D1,-(A7)
       move.l    D2,-(A7)
       bsr       _SectorWrite
       addq.w    #8,A7
       bra.s     WriteTrack_16
WriteTrack_15:
; else
; {
; Error = 30;
       move.b    #30,_Error
WriteTrack_16:
       bra.s     WriteTrack_7
WriteTrack_6:
; //                                                puts("Write attempt to protected disk!\r");
; }
; }
; }
; else
; Error = 27;             /*track number reported in sector header is not the same as current drive track*/
       move.b    #27,_Error
WriteTrack_7:
; }
; if (Error)
       tst.b     _Error
       beq.s     WriteTrack_17
; {
; //                        puts("WriteTrack: error %d\r",Error);
; //                        ErrorMessage("  WriteTrack",Error);
; //                        puts("WriteTrack error \r");
; ErrorMessage("  WriteTrack",Error);
       move.b    _Error,D1
       and.l     #255,D1
       move.l    D1,-(A7)
       pea       @main_43
       bsr       _ErrorMessage
       addq.w    #8,A7
WriteTrack_17:
       bra       WriteTrack_1
WriteTrack_3:
       movem.l   (A7)+,D2/D3/A2
       unlk      A6
       rts
; }
; }
; }
; unsigned char FindSync(struct adfTYPE *drive)
; /*this function reads data from fifo till it finds sync word
; or fifo is empty and dma inactive (so no more data is expected)*/
; {
       xdef      _FindSync
_FindSync:
       link      A6,#-4
       movem.l   D2/D3/A2/A3,-(A7)
       lea       _SPI,A2
       lea       _DisableFpga,A3
; unsigned char c1,c2,c3,c4;
; unsigned short n;
; while (1)
FindSync_1:
; {
; EnableFpga();
       bsr       _EnableFpga
; c1 = SPI(0);                    /*write request signal*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,-4(A6)
; c2 = SPI(0);                    /*track number (cylinder & head)*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,-3(A6)
; if (!(c1&CMD_WRTRCK))
       move.b    -4(A6),D0
       and.l     #255,D0
       and.l     #1,D0
       bne.s     FindSync_4
; break;
       bra       FindSync_3
FindSync_4:
; if (c2 != drive->track)
       move.l    8(A6),A0
       move.b    -3(A6),D0
       cmp.b     68(A0),D0
       beq.s     FindSync_6
; break;
       bra       FindSync_3
FindSync_6:
; c3 = SPI(0)&0xBF;               /*msb of mfm words to transfer*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       and.l     #191,D0
       move.b    D0,D3
; c4 = SPI(0);                    /*lsb of mfm words to transfer*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D2
; if (c3==0 && c4==0)
       and.l     #255,D3
       bne.s     FindSync_8
       and.l     #255,D2
       bne.s     FindSync_8
; break;
       bra       FindSync_3
FindSync_8:
; n = ((c3&0x3F)<<8) + c4;
       and.l     #255,D3
       move.l    D3,D0
       and.l     #63,D0
       asl.l     #8,D0
       and.l     #255,D2
       add.l     D2,D0
       move.w    D0,-2(A6)
; while (n--)
FindSync_10:
       move.w    -2(A6),D0
       subq.w    #1,-2(A6)
       tst.w     D0
       beq       FindSync_12
; {
; c3 = SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D3
; c4 = SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D2
; if (c3==0x44 && c4==0x89)
       and.l     #255,D3
       cmp.l     #68,D3
       bne.s     FindSync_13
       and.l     #255,D2
       cmp.l     #137,D2
       bne.s     FindSync_13
; {
; DisableFpga();
       jsr       (A3)
; /*                      #ifdef DEBUG
; puts("#SYNC:");
; #endif
; */                              return 1;
       moveq     #1,D0
       bra.s     FindSync_15
FindSync_13:
       bra       FindSync_10
FindSync_12:
; }
; }
; DisableFpga();
       jsr       (A3)
       bra       FindSync_1
FindSync_3:
; }
; DisableFpga();
       jsr       (A3)
; return 0;
       clr.b     D0
FindSync_15:
       movem.l   (A7)+,D2/D3/A2/A3
       unlk      A6
       rts
; }
; unsigned char GetHeader(unsigned char *pTrack, unsigned char *pSector)
; /*this function reads data from fifo till it finds sync word or dma is inactive*/
; {
       xdef      _GetHeader
_GetHeader:
       link      A6,#-4
       movem.l   D2/D3/D4/D5/D6/D7/A2/A3/A4/A5,-(A7)
       lea       _SPI,A2
       lea       -4(A6),A3
       lea       _Error,A4
       lea       _DisableFpga,A5
; unsigned char c,c1,c2,c3,c4;
; unsigned char i;
; unsigned char checksum[4];
; Error = 0;
       clr.b     (A4)
; while (1)
GetHeader_1:
; {
; EnableFpga();
       bsr       _EnableFpga
; c1 = SPI(0);                    /*write request signal*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D5
; c2 = SPI(0);                    /*track number (cylinder & head)*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D4
; if (!(c1&CMD_WRTRCK))
       and.l     #255,D5
       move.l    D5,D0
       and.l     #1,D0
       bne.s     GetHeader_4
; break;
       bra       GetHeader_3
GetHeader_4:
; c3 = SPI(0);                    /*msb of mfm words to transfer*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D3
; c4 = SPI(0);                    /*lsb of mfm words to transfer*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D6
; if ((c3&0x3F)!=0 || c4>24)      /*remaining header data is 25 mfm words*/
       and.l     #255,D3
       move.l    D3,D0
       and.l     #63,D0
       bne.s     GetHeader_8
       and.l     #255,D6
       cmp.l     #24,D6
       bls       GetHeader_6
GetHeader_8:
; {
; c1 = SPI(0);            /*second sync lsb*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D5
; c2 = SPI(0);            /*second sync msb*/
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D4
; if (c1!=0x44 || c2!=0x89)
       and.l     #255,D5
       cmp.l     #68,D5
       bne.s     GetHeader_11
       and.l     #255,D4
       cmp.l     #137,D4
       beq.s     GetHeader_9
GetHeader_11:
; {
; Error = 21;
       move.b    #21,(A4)
; //                                puts("\rSecond sync word missing...\r",c1,c2,c3,c4);
; break;
       bra       GetHeader_3
GetHeader_9:
; }
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[0] = c;
       move.b    D2,(A3)
; c1 = (c&0x55)<<1;
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       asl.l     #1,D0
       move.b    D0,D5
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[1] = c;
       move.b    D2,1(A3)
; c2 = (c&0x55)<<1;
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       asl.l     #1,D0
       move.b    D0,D4
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[2] = c;
       move.b    D2,2(A3)
; c3 = (c&0x55)<<1;
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       asl.l     #1,D0
       move.b    D0,D3
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[3] = c;
       move.b    D2,3(A3)
; c4 = (c&0x55)<<1;
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       asl.l     #1,D0
       move.b    D0,D6
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[0] ^= c;
       eor.b     D2,(A3)
; c1 |= c&0x55;
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       or.b      D0,D5
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[1] ^= c;
       eor.b     D2,1(A3)
; c2 |= c&0x55;
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       or.b      D0,D4
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[2] ^= c;
       eor.b     D2,2(A3)
; c3 |= c&0x55;
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       or.b      D0,D3
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[3] ^= c;
       eor.b     D2,3(A3)
; c4 |= c&0x55;
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       or.b      D0,D6
; if (c1 != 0xFF)         /*always 0xFF*/
       and.l     #255,D5
       cmp.l     #255,D5
       beq.s     GetHeader_12
; Error = 22;
       move.b    #22,(A4)
       bra       GetHeader_18
GetHeader_12:
; else if (c2 > 159)              /*Track number (0-159)*/
       and.l     #255,D4
       cmp.l     #159,D4
       bls.s     GetHeader_14
; Error = 23;
       move.b    #23,(A4)
       bra.s     GetHeader_18
GetHeader_14:
; else if (c3 > 10)               /*Sector number (0-10)*/
       and.l     #255,D3
       cmp.l     #10,D3
       bls.s     GetHeader_16
; Error = 24;
       move.b    #24,(A4)
       bra.s     GetHeader_18
GetHeader_16:
; else if (c4>11 || c4==0)        /*Number of sectors to gap (1-11)*/
       and.l     #255,D6
       cmp.l     #11,D6
       bhi.s     GetHeader_20
       and.l     #255,D6
       bne.s     GetHeader_18
GetHeader_20:
; Error = 25;
       move.b    #25,(A4)
GetHeader_18:
; if (Error)
       tst.b     (A4)
       beq.s     GetHeader_21
; {
; //                                puts("\rWrong header: %d.%d.%d.%d\r",c1,c2,c3,c4);
; break;
       bra       GetHeader_3
GetHeader_21:
; }
; /*              #ifdef DEBUG
; puts("T%dS%d\r",c2,c3);
; #endif
; */
; *pTrack = c2;
       move.l    8(A6),A0
       move.b    D4,(A0)
; *pSector = c3;
       move.l    12(A6),A0
       move.b    D3,(A0)
; for (i=0;i<8;i++)
       moveq     #0,D7
GetHeader_23:
       and.l     #255,D7
       cmp.l     #8,D7
       bhs       GetHeader_25
; {
; checksum[0] ^= SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       eor.b     D0,(A3)
; checksum[1] ^= SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       eor.b     D0,1(A3)
; checksum[2] ^= SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       eor.b     D0,2(A3)
; checksum[3] ^= SPI(0);
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       eor.b     D0,3(A3)
       addq.b    #1,D7
       bra       GetHeader_23
GetHeader_25:
; }
; checksum[0] &= 0x55;
       and.b     #85,(A3)
; checksum[1] &= 0x55;
       and.b     #85,1(A3)
; checksum[2] &= 0x55;
       and.b     #85,2(A3)
; checksum[3] &= 0x55;
       and.b     #85,3(A3)
; c1 = (SPI(0)&0x55)<<1;
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       and.l     #85,D0
       asl.l     #1,D0
       move.b    D0,D5
; c2 = (SPI(0)&0x55)<<1;
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       and.l     #85,D0
       asl.l     #1,D0
       move.b    D0,D4
; c3 = (SPI(0)&0x55)<<1;
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       and.l     #85,D0
       asl.l     #1,D0
       move.b    D0,D3
; c4 = (SPI(0)&0x55)<<1;
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       and.l     #85,D0
       asl.l     #1,D0
       move.b    D0,D6
; c1 |= SPI(0)&0x55;
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       and.l     #85,D0
       or.b      D0,D5
; c2 |= SPI(0)&0x55;
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       and.l     #85,D0
       or.b      D0,D4
; c3 |= SPI(0)&0x55;
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       and.l     #85,D0
       or.b      D0,D3
; c4 |= SPI(0)&0x55;
       clr.l     -(A7)
       jsr       (A2)
       addq.w    #4,A7
       and.l     #85,D0
       or.b      D0,D6
; if (c1!=checksum[0] || c2!=checksum[1] || c3!=checksum[2] || c4!=checksum[3])
       cmp.b     (A3),D5
       bne.s     GetHeader_28
       cmp.b     1(A3),D4
       bne.s     GetHeader_28
       cmp.b     2(A3),D3
       bne.s     GetHeader_28
       cmp.b     3(A3),D6
       beq.s     GetHeader_26
GetHeader_28:
; {
; Error = 26;
       move.b    #26,(A4)
; break;
       bra.s     GetHeader_3
GetHeader_26:
; }
; DisableFpga();
       jsr       (A5)
; return 1;
       moveq     #1,D0
       bra.s     GetHeader_29
GetHeader_6:
; }
; else                            /*not enough data for header*/
; if ((c3&0x80)==0)       /*write dma is not active*/
       and.l     #255,D3
       move.l    D3,D0
       and.l     #128,D0
       bne.s     GetHeader_30
; {
; Error = 20;
       move.b    #20,(A4)
; break;
       bra.s     GetHeader_3
GetHeader_30:
; }
; DisableFpga();
       jsr       (A5)
       bra       GetHeader_1
GetHeader_3:
; }
; DisableFpga();
       jsr       (A5)
; return 0;
       clr.b     D0
GetHeader_29:
       movem.l   (A7)+,D2/D3/D4/D5/D6/D7/A2/A3/A4/A5
       unlk      A6
       rts
; }
; unsigned char GetData()
; {
       xdef      _GetData
_GetData:
       link      A6,#-8
       movem.l   D2/D3/D4/D5/D6/D7/A2/A3/A4/A5,-(A7)
       lea       -4(A6),A2
       lea       _SPI,A3
       lea       _DisableFpga,A4
       lea       _Error,A5
; unsigned char c,c1,c2,c3,c4;
; unsigned char i;
; unsigned char *p;
; unsigned short n;
; unsigned char checksum[4];
; Error = 0;
       clr.b     (A5)
; while (1)
GetData_1:
; {
; EnableFpga();
       bsr       _EnableFpga
; c1 = SPI(0);                    /*write request signal*/
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       move.b    D0,D6
; c2 = SPI(0);                    /*track number (cylinder & head)*/
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       move.b    D0,-7(A6)
; if (!(c1&CMD_WRTRCK))
       and.l     #255,D6
       move.l    D6,D0
       and.l     #1,D0
       bne.s     GetData_4
; break;
       bra       GetData_3
GetData_4:
; c3 = SPI(0);                    /*msb of mfm words to transfer*/
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       move.b    D0,D4
; c4 = SPI(0);                    /*lsb of mfm words to transfer*/
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       move.b    D0,D5
; n = ((c3&0x3F)<<8) + c4;
       and.l     #255,D4
       move.l    D4,D0
       and.l     #63,D0
       asl.l     #8,D0
       and.l     #255,D5
       add.l     D5,D0
       move.w    D0,-6(A6)
; if (n >= 0x204)
       move.w    -6(A6),D0
       and.l     #65535,D0
       cmp.l     #516,D0
       blo       GetData_6
; {
; c1 = (SPI(0)&0x55)<<1;
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       and.l     #85,D0
       asl.l     #1,D0
       move.b    D0,D6
; c2 = (SPI(0)&0x55)<<1;
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       and.l     #85,D0
       asl.l     #1,D0
       move.b    D0,-7(A6)
; c3 = (SPI(0)&0x55)<<1;
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       and.l     #85,D0
       asl.l     #1,D0
       move.b    D0,D4
; c4 = (SPI(0)&0x55)<<1;
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       and.l     #85,D0
       asl.l     #1,D0
       move.b    D0,D5
; c1 |= SPI(0)&0x55;
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       and.l     #85,D0
       or.b      D0,D6
; c2 |= SPI(0)&0x55;
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       and.l     #85,D0
       or.b      D0,-7(A6)
; c3 |= SPI(0)&0x55;
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       and.l     #85,D0
       or.b      D0,D4
; c4 |= SPI(0)&0x55;
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       and.l     #85,D0
       or.b      D0,D5
; checksum[0] = 0;
       clr.b     (A2)
; checksum[1] = 0;
       clr.b     1(A2)
; checksum[2] = 0;
       clr.b     2(A2)
; checksum[3] = 0;
       clr.b     3(A2)
; /*odd bits of data field*/
; i = 128;
       move.b    #128,D7
; p = secbuf;
       lea       _secbuf,A0
       move.l    A0,D3
; do
; {
GetData_8:
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[0] ^= c;
       eor.b     D2,(A2)
; *p++ = (c&0x55)<<1;
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       asl.l     #1,D0
       move.l    D3,A0
       addq.l    #1,D3
       move.b    D0,(A0)
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[1] ^= c;
       eor.b     D2,1(A2)
; *p++ = (c&0x55)<<1;
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       asl.l     #1,D0
       move.l    D3,A0
       addq.l    #1,D3
       move.b    D0,(A0)
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[2] ^= c;
       eor.b     D2,2(A2)
; *p++ = (c&0x55)<<1;
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       asl.l     #1,D0
       move.l    D3,A0
       addq.l    #1,D3
       move.b    D0,(A0)
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[3] ^= c;
       eor.b     D2,3(A2)
; *p++ = (c&0x55)<<1;
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       asl.l     #1,D0
       move.l    D3,A0
       addq.l    #1,D3
       move.b    D0,(A0)
       subq.b    #1,D7
       and.l     #255,D7
       bne       GetData_8
; }
; while(--i);
; /*even bits of data field*/
; i = 128;
       move.b    #128,D7
; p = secbuf;
       lea       _secbuf,A0
       move.l    A0,D3
; do
; {
GetData_10:
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[0] ^= c;
       eor.b     D2,(A2)
; *p++ |= c&0x55;
       move.l    D3,A0
       addq.l    #1,D3
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       or.b      D0,(A0)
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[1] ^= c;
       eor.b     D2,1(A2)
; *p++ |= c&0x55;
       move.l    D3,A0
       addq.l    #1,D3
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       or.b      D0,(A0)
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[2] ^= c;
       eor.b     D2,2(A2)
; *p++ |= c&0x55;
       move.l    D3,A0
       addq.l    #1,D3
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       or.b      D0,(A0)
; c = SPI(0);
       clr.l     -(A7)
       jsr       (A3)
       addq.w    #4,A7
       move.b    D0,D2
; checksum[3] ^= c;
       eor.b     D2,3(A2)
; *p++ |= c&0x55;
       move.l    D3,A0
       addq.l    #1,D3
       and.l     #255,D2
       move.l    D2,D0
       and.l     #85,D0
       or.b      D0,(A0)
       subq.b    #1,D7
       and.l     #255,D7
       bne       GetData_10
; }
; while(--i);
; checksum[0] &= 0x55;
       and.b     #85,(A2)
; checksum[1] &= 0x55;
       and.b     #85,1(A2)
; checksum[2] &= 0x55;
       and.b     #85,2(A2)
; checksum[3] &= 0x55;
       and.b     #85,3(A2)
; if (c1!=checksum[0] || c2!=checksum[1] || c3!=checksum[2] || c4!=checksum[3])
       cmp.b     (A2),D6
       bne.s     GetData_14
       move.b    -7(A6),D0
       cmp.b     1(A2),D0
       bne.s     GetData_14
       cmp.b     2(A2),D4
       bne.s     GetData_14
       cmp.b     3(A2),D5
       beq.s     GetData_12
GetData_14:
; {
; Error = 29;
       move.b    #29,(A5)
; break;
       bra.s     GetData_3
GetData_12:
; }
; DisableFpga();
       jsr       (A4)
; return 1;
       moveq     #1,D0
       bra.s     GetData_15
GetData_6:
; }
; else                            /*not enough data in fifo*/
; if ((c3&0x80)==0)       /*write dma is not active*/
       and.l     #255,D4
       move.l    D4,D0
       and.l     #128,D0
       bne.s     GetData_16
; {
; Error = 28;
       move.b    #28,(A5)
; break;
       bra.s     GetData_3
GetData_16:
; }
; DisableFpga();
       jsr       (A4)
       bra       GetData_1
GetData_3:
; }
; DisableFpga();
       jsr       (A4)
; return 0;
       clr.b     D0
GetData_15:
       movem.l   (A7)+,D2/D3/D4/D5/D6/D7/A2/A3/A4/A5
       unlk      A6
       rts
; }
; /*this function sends the data in the sector buffer to the FPGA, translated
; into an Amiga floppy format sector
; sector is the sector number in the track
; track is the track number
; note that we do not insert clock bits because they will be stripped
; by the Amiga software anyway*/
; unsigned short SectorToFpga(unsigned char sector,unsigned char track)
; {
       xdef      _SectorToFpga
_SectorToFpga:
       link      A6,#-8
       movem.l   D2/D3/D4/D5/A2/A3/A4,-(A7)
       lea       -6(A6),A2
       lea       _SPI,A3
       move.b    11(A6),D5
       and.l     #255,D5
       lea       _secbuf,A4
; unsigned char c,i;
; unsigned char csum[4];
; unsigned char *p;
; unsigned char c3,c4;
; /*preamble*/
; SPI(0xaa);
       pea       170
       jsr       (A3)
       addq.w    #4,A7
; SPI(0xaa);
       pea       170
       jsr       (A3)
       addq.w    #4,A7
; SPI(0xaa);
       pea       170
       jsr       (A3)
       addq.w    #4,A7
; SPI(0xaa);
       pea       170
       jsr       (A3)
       addq.w    #4,A7
; /*synchronization*/
; SPI(0x44);
       pea       68
       jsr       (A3)
       addq.w    #4,A7
; SPI(0x89);
       pea       137
       jsr       (A3)
       addq.w    #4,A7
; SPI(0x44);
       pea       68
       jsr       (A3)
       addq.w    #4,A7
; SPI(0x89);
       pea       137
       jsr       (A3)
       addq.w    #4,A7
; /*clear header checksum*/
; csum[0]=0;
       clr.b     (A2)
; csum[1]=0;
       clr.b     1(A2)
; csum[2]=0;
       clr.b     2(A2)
; csum[3]=0;
       clr.b     3(A2)
; /*odd bits of header*/
; c=0x55;
       moveq     #85,D2
; csum[0]^=c;
       eor.b     D2,(A2)
; SPI(c);
       and.l     #255,D2
       move.l    D2,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; c=(track>>1)&0x55;
       move.b    15(A6),D0
       and.l     #255,D0
       asr.l     #1,D0
       and.l     #85,D0
       move.b    D0,D2
; csum[1]^=c;
       eor.b     D2,1(A2)
; SPI(c);
       and.l     #255,D2
       move.l    D2,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; c=(sector>>1)&0x55;
       and.l     #255,D5
       move.l    D5,D0
       asr.l     #1,D0
       and.l     #85,D0
       move.b    D0,D2
; csum[2]^=c;
       eor.b     D2,2(A2)
; SPI(c);
       and.l     #255,D2
       move.l    D2,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; c=((11-sector)>>1)&0x55;
       moveq     #11,D0
       and.l     #255,D5
       sub.l     D5,D0
       asr.l     #1,D0
       and.l     #85,D0
       move.b    D0,D2
; csum[3]^=c;
       eor.b     D2,3(A2)
; SPI(c);
       and.l     #255,D2
       move.l    D2,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; /*even bits of header*/
; c=0x55;
       moveq     #85,D2
; csum[0]^=c;
       eor.b     D2,(A2)
; SPI(c);
       and.l     #255,D2
       move.l    D2,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; c=track&0x55;
       move.b    15(A6),D0
       and.l     #255,D0
       and.l     #85,D0
       move.b    D0,D2
; csum[1]^=c;
       eor.b     D2,1(A2)
; SPI(c);
       and.l     #255,D2
       move.l    D2,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; c=sector&0x55;
       and.l     #255,D5
       move.l    D5,D0
       and.l     #85,D0
       move.b    D0,D2
; csum[2]^=c;
       eor.b     D2,2(A2)
; SPI(c);
       and.l     #255,D2
       move.l    D2,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; c=(11-sector)&0x55;
       moveq     #11,D0
       and.l     #255,D5
       sub.l     D5,D0
       and.l     #85,D0
       move.b    D0,D2
; csum[3]^=c;
       eor.b     D2,3(A2)
; SPI(c);
       and.l     #255,D2
       move.l    D2,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; /*sector label and reserved area (changes nothing to checksum)*/
; for(i=0;i<32;i++)
       clr.b     D4
SectorToFpga_1:
       and.l     #255,D4
       cmp.l     #32,D4
       bhs.s     SectorToFpga_3
; SPI(0x55);
       pea       85
       jsr       (A3)
       addq.w    #4,A7
       addq.b    #1,D4
       bra       SectorToFpga_1
SectorToFpga_3:
; /*checksum over header*/
; SPI((csum[0]>>1)|0xaa);
       move.b    (A2),D1
       and.l     #255,D1
       asr.l     #1,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; SPI((csum[1]>>1)|0xaa);
       move.b    1(A2),D1
       and.l     #255,D1
       asr.l     #1,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; SPI((csum[2]>>1)|0xaa);
       move.b    2(A2),D1
       and.l     #255,D1
       asr.l     #1,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; SPI((csum[3]>>1)|0xaa);
       move.b    3(A2),D1
       and.l     #255,D1
       asr.l     #1,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; SPI(csum[0]|0xaa);
       move.b    (A2),D1
       and.l     #255,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; SPI(csum[1]|0xaa);
       move.b    1(A2),D1
       and.l     #255,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; SPI(csum[2]|0xaa);
       move.b    2(A2),D1
       and.l     #255,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; SPI(csum[3]|0xaa);
       move.b    3(A2),D1
       and.l     #255,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; /*calculate data checksum*/
; csum[0]=0;
       clr.b     (A2)
; csum[1]=0;
       clr.b     1(A2)
; csum[2]=0;
       clr.b     2(A2)
; csum[3]=0;
       clr.b     3(A2)
; i=128;
       move.b    #128,D4
; p=secbuf;
       move.l    A4,D3
; do
; {
SectorToFpga_4:
; c=*(p++);
       move.l    D3,A0
       addq.l    #1,D3
       move.b    (A0),D2
; csum[0]^=c>>1;
       and.l     #255,D2
       move.l    D2,D0
       asr.l     #1,D0
       eor.b     D0,(A2)
; csum[0]^=c;
       eor.b     D2,(A2)
; c=*(p++);
       move.l    D3,A0
       addq.l    #1,D3
       move.b    (A0),D2
; csum[1]^=c>>1;
       and.l     #255,D2
       move.l    D2,D0
       asr.l     #1,D0
       eor.b     D0,1(A2)
; csum[1]^=c;
       eor.b     D2,1(A2)
; c=*(p++);
       move.l    D3,A0
       addq.l    #1,D3
       move.b    (A0),D2
; csum[2]^=c>>1;
       and.l     #255,D2
       move.l    D2,D0
       asr.l     #1,D0
       eor.b     D0,2(A2)
; csum[2]^=c;
       eor.b     D2,2(A2)
; c=*(p++);
       move.l    D3,A0
       addq.l    #1,D3
       move.b    (A0),D2
; csum[3]^=c>>1;
       and.l     #255,D2
       move.l    D2,D0
       asr.l     #1,D0
       eor.b     D0,3(A2)
; csum[3]^=c;
       eor.b     D2,3(A2)
       subq.b    #1,D4
       and.l     #255,D4
       bne       SectorToFpga_4
; }
; while(--i);
; csum[0]&=0x55;
       and.b     #85,(A2)
; csum[1]&=0x55;
       and.b     #85,1(A2)
; csum[2]&=0x55;
       and.b     #85,2(A2)
; csum[3]&=0x55;
       and.b     #85,3(A2)
; /*checksum over data*/
; SPI((csum[0]>>1)|0xaa);
       move.b    (A2),D1
       and.l     #255,D1
       asr.l     #1,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; SPI((csum[1]>>1)|0xaa);
       move.b    1(A2),D1
       and.l     #255,D1
       asr.l     #1,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; SPI((csum[2]>>1)|0xaa);
       move.b    2(A2),D1
       and.l     #255,D1
       asr.l     #1,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; SPI((csum[3]>>1)|0xaa);
       move.b    3(A2),D1
       and.l     #255,D1
       asr.l     #1,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; SPI(csum[0]|0xaa);
       move.b    (A2),D1
       and.l     #255,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; SPI(csum[1]|0xaa);
       move.b    1(A2),D1
       and.l     #255,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; SPI(csum[2]|0xaa);
       move.b    2(A2),D1
       and.l     #255,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; SPI(csum[3]|0xaa);
       move.b    3(A2),D1
       and.l     #255,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; /*odd bits of data field*/
; i=128;
       move.b    #128,D4
; p=secbuf;
       move.l    A4,D3
; do
; {
SectorToFpga_6:
; c=*(p++);
       move.l    D3,A0
       addq.l    #1,D3
       move.b    (A0),D2
; c>>=1;
       lsr.l     #1,D2
; c|=0xaa;
       or.b      #170,D2
; SPI(c);
       and.l     #255,D2
       move.l    D2,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; c=*(p++);
       move.l    D3,A0
       addq.l    #1,D3
       move.b    (A0),D2
; c>>=1;
       lsr.l     #1,D2
; c|=0xaa;
       or.b      #170,D2
; SPI(c);
       and.l     #255,D2
       move.l    D2,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; c=*(p++);
       move.l    D3,A0
       addq.l    #1,D3
       move.b    (A0),D2
; c>>=1;
       lsr.l     #1,D2
; c|=0xaa;
       or.b      #170,D2
; SPI(c);
       and.l     #255,D2
       move.l    D2,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; c=*(p++);
       move.l    D3,A0
       addq.l    #1,D3
       move.b    (A0),D2
; c>>=1;
       lsr.l     #1,D2
; c|=0xaa;
       or.b      #170,D2
; SPI(c);
       and.l     #255,D2
       move.l    D2,-(A7)
       jsr       (A3)
       addq.w    #4,A7
       subq.b    #1,D4
       and.l     #255,D4
       bne       SectorToFpga_6
; }
; while(--i);
; /*even bits of data field*/
; i=128;
       move.b    #128,D4
; p=secbuf;
       move.l    A4,D3
; do
; {
SectorToFpga_8:
; c=*(p++);
       move.l    D3,A0
       addq.l    #1,D3
       move.b    (A0),D2
; SPI(c|0xaa);
       and.l     #255,D2
       move.l    D2,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; c=*(p++);
       move.l    D3,A0
       addq.l    #1,D3
       move.b    (A0),D2
; SPI(c|0xaa);
       and.l     #255,D2
       move.l    D2,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; c=*(p++);
       move.l    D3,A0
       addq.l    #1,D3
       move.b    (A0),D2
; SPI(c|0xaa);
       and.l     #255,D2
       move.l    D2,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
; c=*(p++);
       move.l    D3,A0
       addq.l    #1,D3
       move.b    (A0),D2
; SPI(c|0xaa);
       and.l     #255,D2
       move.l    D2,D1
       or.l      #170,D1
       move.l    D1,-(A7)
       jsr       (A3)
       addq.w    #4,A7
       subq.b    #1,D4
       and.l     #255,D4
       bne       SectorToFpga_8
; }
; while(--i);
; return((c3<<8)|c4);
       move.b    -2(A6),D0
       and.w     #255,D0
       asl.w     #8,D0
       move.b    -1(A6),D1
       and.w     #255,D1
       or.w      D1,D0
       movem.l   (A7)+,D2/D3/D4/D5/A2/A3/A4
       unlk      A6
       rts
; }
; void SectorGapToFpga()
; {
       xdef      _SectorGapToFpga
_SectorGapToFpga:
       link      A6,#-4
; unsigned char i;
; i = 190;
       move.b    #190,-1(A6)
; do
; {
SectorGapToFpga_1:
; SPI(0xAA);
       pea       170
       bsr       _SPI
       addq.w    #4,A7
; SPI(0xAA);
       pea       170
       bsr       _SPI
       addq.w    #4,A7
       subq.b    #1,-1(A6)
       move.b    -1(A6),D0
       ext.w     D0
       move.w    D0,A0
       move.l    A0,D0
       bne       SectorGapToFpga_1
       unlk      A6
       rts
; }
; while (--i);
; }
; void SectorHeaderToFpga(unsigned char n)
; {
       xdef      _SectorHeaderToFpga
_SectorHeaderToFpga:
       link      A6,#0
       movem.l   D2/A2,-(A7)
       lea       _SPI,A2
       move.b    11(A6),D2
       and.l     #255,D2
; if (n)
       tst.b     D2
       beq       SectorHeaderToFpga_5
; {
; SPI(0xAA);
       pea       170
       jsr       (A2)
       addq.w    #4,A7
; SPI(0xAA);
       pea       170
       jsr       (A2)
       addq.w    #4,A7
; if (--n)
       subq.b    #1,D2
       and.l     #255,D2
       beq.s     SectorHeaderToFpga_5
; {
; SPI(0xAA);
       pea       170
       jsr       (A2)
       addq.w    #4,A7
; SPI(0xAA);
       pea       170
       jsr       (A2)
       addq.w    #4,A7
; if (--n)
       subq.b    #1,D2
       and.l     #255,D2
       beq.s     SectorHeaderToFpga_5
; {
; SPI(0x44);
       pea       68
       jsr       (A2)
       addq.w    #4,A7
; SPI(0x89);
       pea       137
       jsr       (A2)
       addq.w    #4,A7
SectorHeaderToFpga_5:
       movem.l   (A7)+,D2/A2
       unlk      A6
       rts
; }
; }
; }
; }
       section   data
       xdef      _filter_msg
_filter_msg:
       dc.l      @main_1,@main_2,@main_3,@main_4
       xdef      _memcfg_msg
_memcfg_msg:
       dc.l      @main_5,@main_6,@main_7,@main_8
@main_1:
       dc.b      110,111,110,101,0
@main_2:
       dc.b      72,79,82,32,0
@main_3:
       dc.b      86,69,82,32,0
@main_4:
       dc.b      72,43,86,32,0
@main_5:
       dc.b      53,49,50,75,32,67,72,73,80,47,56,77,66,0
@main_6:
       dc.b      50,77,101,103,32,67,72,73,80,47,56,77,66,0
@main_7:
       dc.b      53,49,50,75,47,53,49,50,75,47,56,77,66,0
@main_8:
       dc.b      50,77,66,47,49,77,66,47,56,77,66,32,32,0
@main_9:
       dc.b      83,121,115,67,108,117,115,116,101,114,32,102
       dc.b      111,117,110,100,0
@main_10:
       dc.b      78,111,32,102,105,108,101,115,121,115,116,101
       dc.b      109,32,102,111,117,110,100,33,0
@main_11:
       dc.b      75,73,67,75,32,32,32,32,82,79,77,0
@main_12:
       dc.b      32,78,111,32,75,73,67,75,46,82,79,77,32,102
       dc.b      111,117,110,100,33,0
@main_13:
       dc.b      68,70,48,32,32,32,32,32,65,68,70,0
@main_14:
       dc.b      68,70,48,32,32,32,32,32,65,68,70,0
@main_15:
       dc.b      65,68,70,0
@main_16:
       dc.b      32,42,42,32,77,105,110,105,109,105,103,32,77
       dc.b      101,110,117,32,42,42,0
@main_17:
       dc.b      32,32,32,32,32,100,102,48,58,32,0
@main_18:
       dc.b      32,32,32,32,32,100,102,49,58,32,0
@main_19:
       dc.b      45,45,45,45,45,45,45,45,0
@main_20:
       dc.b      32,32,32,32,32,119,114,105,116,97,98,108,101
       dc.b      32,0
@main_21:
       dc.b      32,32,32,32,32,114,101,97,100,32,111,110,108
       dc.b      121,0
@main_22:
       dc.b      32,32,32,32,32,110,111,32,100,105,115,107,32
       dc.b      32,0
@main_23:
       dc.b      32,32,32,32,32,101,106,101,99,116,32,97,100
       dc.b      102,32,0
@main_24:
       dc.b      32,32,32,32,32,105,110,115,101,114,116,32,97
       dc.b      100,102,0
@main_25:
       dc.b      32,32,32,32,32,115,101,116,116,105,110,103,115
       dc.b      0
@main_26:
       dc.b      32,32,32,32,32,114,101,115,101,116,0
@main_27:
       dc.b      32,32,32,32,32,101,120,105,116,0
@main_28:
       dc.b      65,68,70,0
@main_29:
       dc.b      65,68,70,0
@main_30:
       dc.b      65,68,70,0
@main_31:
       dc.b      32,32,32,32,82,101,115,101,116,32,77,105,110
       dc.b      105,109,105,103,63,0
@main_32:
       dc.b      32,32,32,32,32,32,121,101,115,0
@main_33:
       dc.b      32,32,32,32,32,32,110,111,0
@main_34:
       dc.b      32,32,32,42,42,32,83,69,84,84,73,78,71,83,32
       dc.b      42,42,0
@main_35:
       dc.b      32,32,76,111,114,101,115,32,70,105,108,116,101
       dc.b      114,58,32,0
@main_36:
       dc.b      32,32,72,105,114,101,115,32,70,105,108,116,101
       dc.b      114,58,32,0
@main_37:
       dc.b      32,32,82,65,77,58,32,0
@main_38:
       dc.b      32,32,32,32,32,32,32,32,101,120,105,116,0
@main_39:
       dc.b      32,32,32,32,42,42,42,32,69,82,82,79,82,32,42
       dc.b      42,42,0
@main_40:
       dc.b      32,32,101,114,114,111,114,32,35,32,32,32,32
       dc.b      32,0
@main_41:
       dc.b      32,32,32,78,111,32,102,105,108,101,115,33,0
@main_42:
       dc.b      109,111,114,101,32,116,104,101,110,32,56,32
       dc.b      102,114,97,103,109,101,110,116,115,0
@main_43:
       dc.b      32,32,87,114,105,116,101,84,114,97,99,107,0
       section   bss
       xdef      _df0
_df0:
       ds.b      82
       xdef      _df1
_df1:
       ds.b      82
       xdef      _df2
_df2:
       ds.b      82
       xdef      _df3
_df3:
       ds.b      82
       xdef      _aktdrive
_aktdrive:
       ds.b      4
       xdef      _seldrive
_seldrive:
       ds.b      4
       xdef      _file
_file:
       ds.b      26
       xdef      _directory
_directory:
       ds.b      208
       xdef      _dirptr
_dirptr:
       ds.b      1
       xdef      _menustate
_menustate:
       ds.b      1
       xdef      _menusub
_menusub:
       ds.b      1
       ds.b      1
       xdef      _s
_s:
       ds.b      25
       xdef      _lr_filter
_lr_filter:
       ds.b      1
       xdef      _hr_filter
_hr_filter:
       ds.b      1
       xdef      _memcfg
_memcfg:
       ds.b      1
       xdef      _first_dir_entry
_first_dir_entry:
       ds.b      2
       xdef      _Error
_Error:
       ds.b      1
       xdef      _fstype
_fstype:
       ds.b      1
       xref      _OsdMemoryConfig
       xref      _OsdGetCtrl
       xref      _SPI
       xref      _OSD
       xref      _strcpy
       xref      _strncpy
       xref      _OsdFilter
       xref      _SectorWrite
       xref      _SectorRead
       xref      _ReadDir
       xref      _OsdEnable
       xref      _OsdReset
       xref      _HandleHDF
       xref      _OsdDisable
       xref      _kickcopy
       xref      _secbuf
       xref      _cluster
       xref      _MountFile
       xref      _OsdWrite
       xref      _SearchFile
       xref      _OsdClear
       xref      _EnableFpga
       xref      _FindVolume
       xref      _DisableFpga
       xref      _GetSysCluster
       xref      _LoadFile
       xref      _attrib
